searchData={"items":[{"type":"module","doc":"Implementation of the [RTCDataChannel](https://developer.mozilla.org/en-US/docs/Web/API/RTCDataChannel).","title":"ExWebRTC.DataChannel","ref":"ExWebRTC.DataChannel.html"},{"type":"type","doc":"Options used when creating a new DataChannel.\n\nFor more information refer to `ExWebRTC.PeerConnection.create_data_channel/3`.\n\nAs of now, Elixir WebRTC does not support `negotiated: true` option, all DataChannels need to be\nnegotiated in-band.","title":"ExWebRTC.DataChannel.options/0","ref":"ExWebRTC.DataChannel.html#t:options/0"},{"type":"type","doc":"Possible data channel order configurations.\n\nFor the exact meaning, refer to the [RTCDataChannel: order property](https://developer.mozilla.org/en-US/docs/Web/API/RTCDataChannel/readyState).","title":"ExWebRTC.DataChannel.order/0","ref":"ExWebRTC.DataChannel.html#t:order/0"},{"type":"type","doc":"Possible data channel states.\n\nRight now, Elixir WebRTC does not support `:closing` state.\nWhen you close the data channel, it goes from `:open` directly to `:closed`.\n\nFor the exact meaning, refer to the [RTCDataChannel: readyState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCDataChannel/readyState).","title":"ExWebRTC.DataChannel.ready_state/0","ref":"ExWebRTC.DataChannel.html#t:ready_state/0"},{"type":"type","doc":"","title":"ExWebRTC.DataChannel.ref/0","ref":"ExWebRTC.DataChannel.html#t:ref/0"},{"type":"type","doc":"Struct representing the DataChannel.\n\nAll of the fields have the same meaning as in [RTCDataChannel](https://developer.mozilla.org/en-US/docs/Web/API/RTCDataChannel)\nexcept for `ref` which is a local identifier used when refering to this DataChannel in\nreceived messages or when calling `ExWebRTC.PeerConnection.send_data/3` function.\n\nIt's worth to mention that `id` and `label` can be used by the other peer to identify the data\nchannel, althought be careful as:\n* `label` does not have to be unique, channels can share a single label,\n* `id` is only assigned after the SCTP connection has been established (which means\nthat DataChannels created before first negotiation will have `id` set to `nil`)","title":"ExWebRTC.DataChannel.t/0","ref":"ExWebRTC.DataChannel.html#t:t/0"},{"type":"module","doc":"ICE IP filter for Fly.io deployments.\n\nThis module defines a single function, which filters IP addresses,\nwhich ICE Agent will use as its host candidates.\nIt accepts only the IPv4 address that `fly-global-services` resolves to.","title":"ExWebRTC.ICE.FlyIpFilter","ref":"ExWebRTC.ICE.FlyIpFilter.html"},{"type":"function","doc":"","title":"ExWebRTC.ICE.FlyIpFilter.ip_filter/1","ref":"ExWebRTC.ICE.FlyIpFilter.html#ip_filter/1"},{"type":"module","doc":"Implementation of the [RTCIceCandidate](https://www.w3.org/TR/webrtc/#rtcicecandidate-interface).","title":"ExWebRTC.ICECandidate","ref":"ExWebRTC.ICECandidate.html"},{"type":"function","doc":"","title":"ExWebRTC.ICECandidate.from_json/1","ref":"ExWebRTC.ICECandidate.html#from_json/1"},{"type":"type","doc":"","title":"ExWebRTC.ICECandidate.t/0","ref":"ExWebRTC.ICECandidate.html#t:t/0"},{"type":"function","doc":"","title":"ExWebRTC.ICECandidate.to_json/1","ref":"ExWebRTC.ICECandidate.html#to_json/1"},{"type":"module","doc":"Mimics [MediaStreamTrack](https://www.w3.org/TR/mediacapture-streams/#dom-mediastreamtrack).","title":"ExWebRTC.MediaStreamTrack","ref":"ExWebRTC.MediaStreamTrack.html"},{"type":"function","doc":"","title":"ExWebRTC.MediaStreamTrack.generate_stream_id/0","ref":"ExWebRTC.MediaStreamTrack.html#generate_stream_id/0"},{"type":"type","doc":"","title":"ExWebRTC.MediaStreamTrack.id/0","ref":"ExWebRTC.MediaStreamTrack.html#t:id/0"},{"type":"type","doc":"","title":"ExWebRTC.MediaStreamTrack.kind/0","ref":"ExWebRTC.MediaStreamTrack.html#t:kind/0"},{"type":"function","doc":"","title":"ExWebRTC.MediaStreamTrack.new/2","ref":"ExWebRTC.MediaStreamTrack.html#new/2"},{"type":"type","doc":"","title":"ExWebRTC.MediaStreamTrack.rid/0","ref":"ExWebRTC.MediaStreamTrack.html#t:rid/0"},{"type":"type","doc":"","title":"ExWebRTC.MediaStreamTrack.stream_id/0","ref":"ExWebRTC.MediaStreamTrack.html#t:stream_id/0"},{"type":"type","doc":"","title":"ExWebRTC.MediaStreamTrack.t/0","ref":"ExWebRTC.MediaStreamTrack.html#t:t/0"},{"type":"module","doc":"Implementation of the [RTCPeerConnection](https://www.w3.org/TR/webrtc/#dom-rtcpeerconnection).","title":"ExWebRTC.PeerConnection","ref":"ExWebRTC.PeerConnection.html"},{"type":"function","doc":"Adds a new remote ICE candidate.\n\nFor more information, refer to the [RTCPeerConnection: addIceCandidate() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/addIceCandidate).","title":"ExWebRTC.PeerConnection.add_ice_candidate/2","ref":"ExWebRTC.PeerConnection.html#add_ice_candidate/2"},{"type":"function","doc":"Adds a new track.\n\nFor more information, refer to the [RTCPeerConnection: addTrack() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/addTrack).","title":"ExWebRTC.PeerConnection.add_track/2","ref":"ExWebRTC.PeerConnection.html#add_track/2"},{"type":"function","doc":"Adds a new transceiver.\n\nFor more information, refer to the [RTCPeerConnection: addTransceiver() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/addTransceiver).","title":"ExWebRTC.PeerConnection.add_transceiver/3","ref":"ExWebRTC.PeerConnection.html#add_transceiver/3"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"ExWebRTC.PeerConnection.child_spec/1","ref":"ExWebRTC.PeerConnection.html#child_spec/1"},{"type":"function","doc":"Closes the PeerConnection.\n\nThis function kills the `peer_connection` process.\nFor more information, refer to the [RTCPeerConnection: close() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/close).","title":"ExWebRTC.PeerConnection.close/1","ref":"ExWebRTC.PeerConnection.html#close/1"},{"type":"function","doc":"Closes a DataChannel identified by `ref`.\n\nAs of now, the closed channel directly transitions to closed state,\nwhich is signaled with `{:data_channel_state_change, ref, :closed}` message.\nFor more information, refer to the [RTCDataChannel: close() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCDataChannel/close).\n\nIf `ref` does not identify any DataChannel, this function behaves like no-op.","title":"ExWebRTC.PeerConnection.close_data_channel/2","ref":"ExWebRTC.PeerConnection.html#close_data_channel/2"},{"type":"type","doc":"Possible connection states.\n\nFor the exact meaning, refer to the [RTCPeerConnection: connectionState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/connectionState).","title":"ExWebRTC.PeerConnection.connection_state/0","ref":"ExWebRTC.PeerConnection.html#t:connection_state/0"},{"type":"function","doc":"Changes the controlling process of this `peer_connection` process.\n\nControlling process is a process that receives all of the messages (described\nby `t:message/0`) from this PeerConnection.","title":"ExWebRTC.PeerConnection.controlling_process/2","ref":"ExWebRTC.PeerConnection.html#controlling_process/2"},{"type":"function","doc":"Creates an SDP answer.\n\nFor more information, refer to the [RTCPeerConnection: createAnswer() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/createAnswer).","title":"ExWebRTC.PeerConnection.create_answer/1","ref":"ExWebRTC.PeerConnection.html#create_answer/1"},{"type":"function","doc":"Creates a new DataChannel.\n\nFor more information, refer to the [RTCPeerConnection: createDataChannel() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/createDataChannel).","title":"ExWebRTC.PeerConnection.create_data_channel/3","ref":"ExWebRTC.PeerConnection.html#create_data_channel/3"},{"type":"function","doc":"Creates an SDP offer.\n\nFor more information, refer to the [RTCPeerConnection: createOffer() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/createOffer).","title":"ExWebRTC.PeerConnection.create_offer/2","ref":"ExWebRTC.PeerConnection.html#create_offer/2"},{"type":"type","doc":"Possible DTLS transport states.\n\nFor the exact meaning, refer to the [RTCDtlsTransport: state property](https://developer.mozilla.org/en-US/docs/Web/API/RTCDtlsTransport/state)","title":"ExWebRTC.PeerConnection.dtls_transport_state/0","ref":"ExWebRTC.PeerConnection.html#t:dtls_transport_state/0"},{"type":"function","doc":"Returns a list of all running `ExWebRTC.PeerConnection` processes.","title":"ExWebRTC.PeerConnection.get_all_running/0","ref":"ExWebRTC.PeerConnection.html#get_all_running/0"},{"type":"function","doc":"Returns current `peer_connection` configuration.\n\nNote: the configuration may change after applying remote description.","title":"ExWebRTC.PeerConnection.get_configuration/1","ref":"ExWebRTC.PeerConnection.html#get_configuration/1"},{"type":"function","doc":"Returns the connection state.\n\nFor more information, refer to the [RTCPeerConnection: connectionState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/connectionState).","title":"ExWebRTC.PeerConnection.get_connection_state/1","ref":"ExWebRTC.PeerConnection.html#get_connection_state/1"},{"type":"function","doc":"Returns the current local description.\n\nFor more information, refer to the [RTCPeerConnection: currentLocalDescription property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/currentLocalDescription).","title":"ExWebRTC.PeerConnection.get_current_local_description/1","ref":"ExWebRTC.PeerConnection.html#get_current_local_description/1"},{"type":"function","doc":"Returns the current remote description.\n\nFor more information, refer to the [RTCPeerConnection: currentRemoteDescription property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/currentRemoteDescription).","title":"ExWebRTC.PeerConnection.get_current_remote_description/1","ref":"ExWebRTC.PeerConnection.html#get_current_remote_description/1"},{"type":"function","doc":"Returns `t:ExWebRTC.DataChannel.t()` identified by `channel_ref` if it exists, `nil` otherwise.\n\nThis function can be especially helpful when you want to obtain DataChannel `id`. Normally,\nbefore SCTP connection is established, `create_data_channel/3` will return DataChannel struct\nwith `id` set to `nil`. After receiving `{:data_channel_state_change, ref, :open}` message,\nyou can call this function to obtain the same struct, but with `id` set to proper value.","title":"ExWebRTC.PeerConnection.get_data_channel/2","ref":"ExWebRTC.PeerConnection.html#get_data_channel/2"},{"type":"function","doc":"Returns the DTLS transport state.\n\nFor more information, refer to the [RTCDtlsTransport: state property](https://developer.mozilla.org/en-US/docs/Web/API/RTCDtlsTransport/state).","title":"ExWebRTC.PeerConnection.get_dtls_transport_state/1","ref":"ExWebRTC.PeerConnection.html#get_dtls_transport_state/1"},{"type":"function","doc":"Returns the ICE connection state.\n\nFor more information, refer to the [RTCPeerConnection: iceConnectionState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/iceConnectionState).","title":"ExWebRTC.PeerConnection.get_ice_connection_state/1","ref":"ExWebRTC.PeerConnection.html#get_ice_connection_state/1"},{"type":"function","doc":"Returns the ICE gathering state.\n\nFor more information, refer to the [RTCPeerConnection: iceGatheringState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/iceGatheringState).","title":"ExWebRTC.PeerConnection.get_ice_gathering_state/1","ref":"ExWebRTC.PeerConnection.html#get_ice_gathering_state/1"},{"type":"function","doc":"Returns the local description.\n\nFor more information, refer to the [RTCPeerConnection: localDescription property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/localDescription).","title":"ExWebRTC.PeerConnection.get_local_description/1","ref":"ExWebRTC.PeerConnection.html#get_local_description/1"},{"type":"function","doc":"Returns the pending local description.\n\nFor more information, refer to the [RTCPeerConnection: pendingLocalDescription property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/pendingLocalDescription).","title":"ExWebRTC.PeerConnection.get_pending_local_description/1","ref":"ExWebRTC.PeerConnection.html#get_pending_local_description/1"},{"type":"function","doc":"Returns the pending remote description.\n\nFor more information, refer to the [RTCPeerConnection: pendingRemoteDescription property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/pendingRemoteDescription).","title":"ExWebRTC.PeerConnection.get_pending_remote_description/1","ref":"ExWebRTC.PeerConnection.html#get_pending_remote_description/1"},{"type":"function","doc":"Returns the remote description.\n\nFor more information, refer to the [RTCPeerConnection: remoteDescription property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/remoteDescription).","title":"ExWebRTC.PeerConnection.get_remote_description/1","ref":"ExWebRTC.PeerConnection.html#get_remote_description/1"},{"type":"function","doc":"Returns the signaling state.\n\nFor more information, refer to the [RTCPeerConnection: signalingState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/signalingState).","title":"ExWebRTC.PeerConnection.get_signaling_state/1","ref":"ExWebRTC.PeerConnection.html#get_signaling_state/1"},{"type":"function","doc":"Returns PeerConnection's statistics.\n\nFor more information, refer to the [RTCPeerConnection: getStats() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/getStats).\nSee [RTCStatsReport](https://www.w3.org/TR/webrtc/#rtcstatsreport-object) for the output structure.","title":"ExWebRTC.PeerConnection.get_stats/1","ref":"ExWebRTC.PeerConnection.html#get_stats/1"},{"type":"function","doc":"Returns the list of transceivers.\n\nFor more information, refer to the [RTCPeerConnection: getTransceivers() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/getTransceivers).","title":"ExWebRTC.PeerConnection.get_transceivers/1","ref":"ExWebRTC.PeerConnection.html#get_transceivers/1"},{"type":"type","doc":"Possible ICE connection states.\n\nFor the exact meaning, refer to the [RTCPeerConnection: iceConnectionState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/iceConnectionState).","title":"ExWebRTC.PeerConnection.ice_connection_state/0","ref":"ExWebRTC.PeerConnection.html#t:ice_connection_state/0"},{"type":"type","doc":"Possible ICE gathering states.\n\nFor the exact meaning, refer to the [RTCPeerConnection: iceGatheringState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/iceGatheringState).","title":"ExWebRTC.PeerConnection.ice_gathering_state/0","ref":"ExWebRTC.PeerConnection.html#t:ice_gathering_state/0"},{"type":"type","doc":"Messages sent by the `ExWebRTC.PeerConnection` process to its controlling process.\n\nMost of the messages match the [RTCPeerConnection events](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection#events),\nexcept for:\n* `:dtls_transport_state_change` - traditional WebRTC implementation does not emit such event.\nInstead, developer can read DTLS transport state by iterating over RTP receivers/senders, and checking their\nDTLS transports states. See https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpSender/transport.\nHowever, because Elixir WebRTC creates a single DTLS transport for all receivers and senders, there is one generic\nnotification for convenience and parity with other events informing about ice/signaling/connection state changes.\n* `:track_muted`, `:track_ended` - these match the [MediaStreamTrack events](https://developer.mozilla.org/en-US/docs/Web/API/MediaStreamTrack#events).\n* `:data` - data received from DataChannel identified by its `ref`.\n* `:rtp` and `:rtcp` - these contain packets received by the PeerConnection. The third element of `:rtp` tuple is a simulcast RID and is set to `nil` if simulcast\nis not used.\n* each of the packets in `:rtcp` message is in the form of `{track_id, packet}` tuple, where `track_id` is the id of the corrsponding track.\nIn case of PLI and NACK, this is the id of an outgoing (sender's) track id, in case of Sender and Receiver Reports - incoming (receiver's) track id.\nIf matching to a track was not possible (like in the case of TWCC packedts), `track_id` is set to `nil`.","title":"ExWebRTC.PeerConnection.message/0","ref":"ExWebRTC.PeerConnection.html#t:message/0"},{"type":"type","doc":"","title":"ExWebRTC.PeerConnection.peer_connection/0","ref":"ExWebRTC.PeerConnection.html#t:peer_connection/0"},{"type":"function","doc":"Removes the track assigned to the sender specified by the `sender_id`.\n\nFor more information, refer to the [RTCPeerConnection: removeTrack() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/removeTrack).","title":"ExWebRTC.PeerConnection.remove_track/2","ref":"ExWebRTC.PeerConnection.html#remove_track/2"},{"type":"function","doc":"Replaces the track assigned to the sender specified by the `sender_id`.\n\nFor more information, refer to the [RTCRtpSender: replaceTrack() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpSender/replaceTrack).","title":"ExWebRTC.PeerConnection.replace_track/3","ref":"ExWebRTC.PeerConnection.html#replace_track/3"},{"type":"function","doc":"Sends data over DataChannel, using channel identified by `ref`.\n\nRequires the channel to be in `:open` state.\n\nIf `ref` does not identify any DataChannel, this function behaves like no-op.","title":"ExWebRTC.PeerConnection.send_data/4","ref":"ExWebRTC.PeerConnection.html#send_data/4"},{"type":"function","doc":"Sends an RTCP PLI feedback to the remote peer using the track specified by the `track_id`.\n\nSet `rid` to the simulcast `rid` for which the PLI should be sent. If simulcast is not used, `rid` should\nbe equal to `nil`.","title":"ExWebRTC.PeerConnection.send_pli/3","ref":"ExWebRTC.PeerConnection.html#send_pli/3"},{"type":"function","doc":"Sends an RTP packet to the remote peer using the track specified by the `track_id`.\n\nThe following fields of the RTP packet will be overwritten by this function:\n* payload type\n* ssrc\n* rtp header extensions\n\nIf you negotiated multiple codecs (hence payload types) and you want to choose,\nwhich one should be used, see `set_sender_codec/3`.\n\nOptions:\n  * `rtx?` - send the packet as if it was retransmitted (use SSRC and payload type specific to RTX)","title":"ExWebRTC.PeerConnection.send_rtp/4","ref":"ExWebRTC.PeerConnection.html#send_rtp/4"},{"type":"function","doc":"Sets the local description.\n\nFor more information, refer to the [RTCPeerConnection: setLocalDescription() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/setLocalDescription).","title":"ExWebRTC.PeerConnection.set_local_description/2","ref":"ExWebRTC.PeerConnection.html#set_local_description/2"},{"type":"function","doc":"Sets very simple packet loss.\n\nCan be used for experimental purposes.","title":"ExWebRTC.PeerConnection.set_packet_loss/2","ref":"ExWebRTC.PeerConnection.html#set_packet_loss/2"},{"type":"function","doc":"Sets the remote description.\n\nFor more information, refer to the [RTCPeerConnection: setRemoteDescription() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/setRemoteDescription).","title":"ExWebRTC.PeerConnection.set_remote_description/2","ref":"ExWebRTC.PeerConnection.html#set_remote_description/2"},{"type":"function","doc":"Sets the codec that will be used for sending RTP packets.\n\n`send_rtp/4` overrides some of the RTP packet fields.\nIn particular, when multiple codecs are negotiated, `send_rtp/4` will use\npayload type of the most preffered by the remote side codec (i.e. the first\none from the list of codecs in the remote description).\n\nUse this function if you want to select, which codec (hence payload type)\nshould be used for sending.\n\nOnce the first RTP packet is sent (via `send_rtp/4`), `set_sender_codec/3`\ncan only be called with a codec with the same clock rate.\n\nAlthough very unlikely, keep in mind that after renegotiation,\nthe selected codec may no longer be supported by the remote side and you might\nneed to call this function again, passing a new codec.\n\nTo check available codecs you can use `get_transceivers/1`:\n\n```\n{:ok, pc} = PeerConnection.start_link()\n{:ok, rtp_sender} = PeerConnection.add_track(MediaStreamTrack.new(:video))\n\n# exchange SDP with the remote side\n# {:ok, offer} = PeerConnection.create_offer(pc)\n# ...\n\ntr =\n  pc\n  |> PeerConnection.get_transceivers()\n  |> Enum.find(fn tr -> tr.sender.id == rtp_sender.id end)\n\ndbg(tr.codecs) # list of supported codecs both for sending and receiving\n\n# e.g. always prefer h264 over vp8\nh264 = Enum.find(tr.codecs, fn codec -> codec.mime_type == \"video/H264\" end)\nvp8 = Enum.find(tr.codecs, fn codec -> codec.mime_type == \"video/VP8\" end)\n\n:ok = PeerConnection.set_sender_codec(pc, rtp_sender.id, h264 || vp8)\n```\n\nThis function can only be called once the first negotiation passes.","title":"ExWebRTC.PeerConnection.set_sender_codec/3","ref":"ExWebRTC.PeerConnection.html#set_sender_codec/3"},{"type":"function","doc":"Sets the direction of transceiver specified by the `transceiver_id`.\n\nFor more information, refer to the [RTCRtpTransceiver: direction property](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpTransceiver/direction).","title":"ExWebRTC.PeerConnection.set_transceiver_direction/3","ref":"ExWebRTC.PeerConnection.html#set_transceiver_direction/3"},{"type":"type","doc":"Possible signaling states.\n\nFor the exact meaning, refer to the [RTCPeerConnection: signalingState property](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/signalingState).","title":"ExWebRTC.PeerConnection.signaling_state/0","ref":"ExWebRTC.PeerConnection.html#t:signaling_state/0"},{"type":"function","doc":"Starts a new `ExWebRTC.PeerConnection` process.\n\n`ExWebRTC.PeerConnection` is a `GenServer` under the hood, thus this function allows for\npassing the generic `t:GenServer.options/0` as an argument.","title":"ExWebRTC.PeerConnection.start/2","ref":"ExWebRTC.PeerConnection.html#start/2"},{"type":"function","doc":"Starts a new `ExWebRTC.PeerConnection` process.\n\nWorks identically to `start/2`, but links to the calling process.","title":"ExWebRTC.PeerConnection.start_link/2","ref":"ExWebRTC.PeerConnection.html#start_link/2"},{"type":"function","doc":"Stops the transceiver specified by the `transceiver_id`.\n\nFor more information, refer to the [RTCRtpTransceiver: stop() method](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpTransceiver/stop).","title":"ExWebRTC.PeerConnection.stop_transceiver/2","ref":"ExWebRTC.PeerConnection.html#stop_transceiver/2"},{"type":"module","doc":"`ExWebRTC.PeerConnection` configuration.","title":"ExWebRTC.PeerConnection.Configuration","ref":"ExWebRTC.PeerConnection.Configuration.html"},{"type":"type","doc":"Allowed audio codec names which will get expanded to the relevant default `t:ExWebRTC.RTPCodecParameters.t/0`","title":"ExWebRTC.PeerConnection.Configuration.audio_codec_name/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:audio_codec_name/0"},{"type":"function","doc":"Returns a list of default audio codecs.","title":"ExWebRTC.PeerConnection.Configuration.default_audio_codecs/0","ref":"ExWebRTC.PeerConnection.Configuration.html#default_audio_codecs/0"},{"type":"function","doc":"Returns a list of PeerConnection features enabled by default.","title":"ExWebRTC.PeerConnection.Configuration.default_features/0","ref":"ExWebRTC.PeerConnection.Configuration.html#default_features/0"},{"type":"function","doc":"Returns a list of default RTCP feedbacks include in SDP offer/answer.","title":"ExWebRTC.PeerConnection.Configuration.default_rtcp_feedbacks/0","ref":"ExWebRTC.PeerConnection.Configuration.html#default_rtcp_feedbacks/0"},{"type":"function","doc":"Returns a list of default RTP header extensions to include in SDP offer/answer.","title":"ExWebRTC.PeerConnection.Configuration.default_rtp_header_extensions/0","ref":"ExWebRTC.PeerConnection.Configuration.html#default_rtp_header_extensions/0"},{"type":"function","doc":"Returns a list of default video codecs.","title":"ExWebRTC.PeerConnection.Configuration.default_video_codecs/0","ref":"ExWebRTC.PeerConnection.Configuration.html#default_video_codecs/0"},{"type":"type","doc":"Features provided by the ExWebRTC's PeerConnection:\n\n* `:twcc` - ExWebRTC's PeerConnection will generate TWCC RTCP feedbacks based on incoming packets and\nsend them to the remote peer (implicitly adds the `http://www.ietf.org/id/draft-holmer-rmcat-transport-wide-cc-extensions-01` to negotiated\nRTP header extensions and `:twcc` RTCP feedback to all of the negotiated codecs, both audio and video).\n* `:inbound_rtx` - ExWebRTC's PeerConnection will generate NACK RTCP feedbacks in response to missing incoming video packets and properly handle incoming\nretransmissions (implicitly adds the `:nack` RTCP feedback and a matching `a=rtpmap:[id] rtx/...` attribute for every negotiated video codec).\n* `:outbound_rtx` - ExWebRTC's PeerConnection will respond to incoming NACK RTCP feedbacks and retransmit packets accordingly (implicitly adds the same\nattributes as `:inbound_rtx`).\n* `:rtcp_reports` - ExWebRTC's PeerConnection will generate and send RTCP Sender/Receiver Reports based on incoming/send RTP packets.\n\nUse `default_features/0` to get the list of features enabled by default. When passing a list of features to\n`t:options/0`, it will override the default features.","title":"ExWebRTC.PeerConnection.Configuration.feature/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:feature/0"},{"type":"type","doc":"ICE (STUN and/or TURN) server used to create the ICE connection.","title":"ExWebRTC.PeerConnection.Configuration.ice_server/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:ice_server/0"},{"type":"type","doc":"Options that can be passed to `ExWebRTC.PeerConnection.start_link/1`.\n\n* `controlling_process` - a pid of a process where all messages will be sent. `self()` by default,\n* `ice_servers` - list of STUN/TURN servers to use. By default, no servers are provided.\n* `ice_transport_policy` - which type of ICE candidates should be used. Defaults to `:all`.\n* `ice_ip_filter` - filter applied when gathering local candidates. By default, all IP addresses are accepted.\n* `ice_port_range` - range of ports that ICE will use for gathering host candidates. Defaults to ephemeral ports.\n* `ice_aggressive_nomination` - whether ICE agent should use aggressive nomination. By default, ICE agent\nrelies on the regular nomination defined in RFC 8445. However, some WebRTC implementations require\nthe controlling side to nominate a pair before they can start sending data (e.g. Pion, Firefox).\nThis can result in longer, connection establishment time as regular nomination nominates only one pair,\nat the very end of the whole connection establishment process. To mitigate this issue, you can eitehr add an empty\nICE candidate (this will indicate that there won't be further remote candidates and once all connectivity checks pass,\nICE will nominate the pair), or use aggressive nomination. Defaults to false.\n* `audio_codecs` and `video_codecs` - lists of audio and video codecs to negotiate. By default these are equal to\n`default_audio_codecs/0` and `default_video_codecs/0`. To extend the list with your own codecs, do\n`audio_codecs: Configuration.default_audio_codecs() ++ my_codecs`.\nTo use a subset of the default codecs, you can pass the atoms defined in `t:audio_codec_name/0` and `t:video_codec_name/0`.\n* `features` - feature flags for some of the ExWebRTC functinalities. Refer to `t:feature/0` for more information.\n* `rtp_header_extensions` - list of RTP header extensions to negotiate. Refer to `t:rtp_header_extension/0` for more information.\n* `rtcp_feedbacks` - list of RTCP feedbacks to negotiate. Refer to `t:rtcp_feedback/0` for more information.\n\nInstead of manually enabling an RTP header extension or an RTCP feedback, you may want to use a `t:feature/0`, which will enable\nnecessary header extensions under the hood. If you enable RTCP feedback/RTP header extension corresponding to some feature (but not the feature itself),\nthe functionality might not work (e.g. even if you enable TWCC RTP header extension and TWCC feedbacks, without enabling the `:twcc` features, TWCC feedbacks\nwon't be sent).\n\nExWebRTC does not allow for configuration of some of the W3C options, but behaves as if these values were used:\n* bundle_policy - `max_bundle`\n* ice_candidate_pool_size - `0`\n* rtcp_mux_policy - `require`","title":"ExWebRTC.PeerConnection.Configuration.options/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:options/0"},{"type":"type","doc":"RTCP feedbacks that are going to be added by default to all of the codecs.\n\nUse `default_rtcp_feedbacks/0` to check the RTCP feedbacks included by default. When passing a\nlist of RTPC feedbacks to `t:options/0`, it will override the default feedbacks.\n\nBe aware that some of the features (see `t:feature/0`) can implicitly add RTCP feedbacks.","title":"ExWebRTC.PeerConnection.Configuration.rtcp_feedback/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:rtcp_feedback/0"},{"type":"type","doc":"RTP header extension that are going to be included in the SDP offer/answer.\n\nKeep in mind that you are free to pass any RTP header extension URI, but the underlying\nRTP parsing library (`ex_rtp`) might not support it. In such case, you have to parse the\nheader extension yourself.\n\nThis header extension will be included in all of the m-lines of provided `type` (or for both audio and video\nif `:all` is used).\n\nUse `default_rtp_header_extensions/0` to check the RTP header extensions included by default.\nWhen passing a list of RTP header extensions to `t:options/0`, it will override the default RTP header extensions.\n\nBe aware that some of the features (see `t:feature/0`) can implicitly add RTP header extensions).","title":"ExWebRTC.PeerConnection.Configuration.rtp_header_extension/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:rtp_header_extension/0"},{"type":"type","doc":"`ExWebRTC.PeerConnection` configuration.\n\nIt is created from options passed to `ExWebRTC.PeerConnection.start_link/1`.\nSee `t:options/0` for more.","title":"ExWebRTC.PeerConnection.Configuration.t/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:t/0"},{"type":"type","doc":"Allowed video codec names which will get expanded to the relevant default `t:ExWebRTC.RTPCodecParameters.t/0`","title":"ExWebRTC.PeerConnection.Configuration.video_codec_name/0","ref":"ExWebRTC.PeerConnection.Configuration.html#t:video_codec_name/0"},{"type":"module","doc":"Implementation of the [RTCRtpCodecParameters](https://www.w3.org/TR/webrtc/#rtcrtpcodecparameters).","title":"ExWebRTC.RTPCodecParameters","ref":"ExWebRTC.RTPCodecParameters.html"},{"type":"function","doc":"","title":"ExWebRTC.RTPCodecParameters.new/4","ref":"ExWebRTC.RTPCodecParameters.html#new/4"},{"type":"type","doc":"RTP codec parameters.\n\n* `payload_type` - payload type used to identify the codec.\nKeep in mind that the actual payload type depends on who sends the SDP offer first.\nIf the browser sends it first and uses a different payload type for the same codec, \nElixir WebRTC will override its settings and use the payload type provided by the browser.\nIf Elixir WebRTC sends the offer first and uses a different payload type for the same codec, \nthe browser will override its settings and use the payload type provided by Elixir WebRTC.\n\nFor the meanings of the other fields, refer to the [MDN documentation](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpSender/getParameters#codecs)","title":"ExWebRTC.RTPCodecParameters.t/0","ref":"ExWebRTC.RTPCodecParameters.html#t:t/0"},{"type":"module","doc":"Implementation of the [RTCRtpReceiver](https://www.w3.org/TR/webrtc/#rtcrtpreceiver-interface).","title":"ExWebRTC.RTPReceiver","ref":"ExWebRTC.RTPReceiver.html"},{"type":"type","doc":"","title":"ExWebRTC.RTPReceiver.id/0","ref":"ExWebRTC.RTPReceiver.html#t:id/0"},{"type":"type","doc":"Struct representing a receiver.\n\nThe fields mostly match these of [RTCRtpReceiver](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpReceiver),\nexcept for:\n* `id` - to uniquely identify the receiver.\n* `codec` - codec this receiver is expected to receive.","title":"ExWebRTC.RTPReceiver.t/0","ref":"ExWebRTC.RTPReceiver.html#t:t/0"},{"type":"module","doc":"Implementation of the [RTCRtpSender](https://www.w3.org/TR/webrtc/#rtcrtpsender-interface).","title":"ExWebRTC.RTPSender","ref":"ExWebRTC.RTPSender.html"},{"type":"function","doc":"","title":"ExWebRTC.RTPSender.do_send_packet/3","ref":"ExWebRTC.RTPSender.html#do_send_packet/3"},{"type":"type","doc":"","title":"ExWebRTC.RTPSender.id/0","ref":"ExWebRTC.RTPSender.html#t:id/0"},{"type":"type","doc":"Struct representing a sender.\n\nThe fields mostly match these of [RTCRtpSender](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpSender),\nexcept for:\n* `id` - to uniquely identify the sender.\n* `codec` - codec this sender is going to send.","title":"ExWebRTC.RTPSender.t/0","ref":"ExWebRTC.RTPSender.html#t:t/0"},{"type":"module","doc":"Implementation of the [RTCRtpTransceiver](https://www.w3.org/TR/webrtc/#dom-rtcrtptransceiver).","title":"ExWebRTC.RTPTransceiver","ref":"ExWebRTC.RTPTransceiver.html"},{"type":"type","doc":"Possible directions of the transceiver.\n\nFor the exact meaning, refer to the [RTCRtpTransceiver: direction property](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpTransceiver/direction).","title":"ExWebRTC.RTPTransceiver.direction/0","ref":"ExWebRTC.RTPTransceiver.html#t:direction/0"},{"type":"type","doc":"","title":"ExWebRTC.RTPTransceiver.id/0","ref":"ExWebRTC.RTPTransceiver.html#t:id/0"},{"type":"type","doc":"Possible types of media that a transceiver can handle.","title":"ExWebRTC.RTPTransceiver.kind/0","ref":"ExWebRTC.RTPTransceiver.html#t:kind/0"},{"type":"type","doc":"Struct representing a transceiver.\n\nThe fields mostly match these of [RTCRtpTransceiver](https://developer.mozilla.org/en-US/docs/Web/API/RTCRtpTransceiver),\nexcept for:\n* `id` - to uniquely identify the transceiver.\n* `kind` - kind of the handled media, added for convenience.\n* `codecs` and `header_extensions` - codecs and RTP header extensions that the transceiver can handle.","title":"ExWebRTC.RTPTransceiver.t/0","ref":"ExWebRTC.RTPTransceiver.html#t:t/0"},{"type":"module","doc":"Implementation of the [RTCSessionDescription](https://www.w3.org/TR/webrtc/#rtcsessiondescription-class).","title":"ExWebRTC.SessionDescription","ref":"ExWebRTC.SessionDescription.html"},{"type":"type","doc":"","title":"ExWebRTC.SessionDescription.description_type/0","ref":"ExWebRTC.SessionDescription.html#t:description_type/0"},{"type":"function","doc":"","title":"ExWebRTC.SessionDescription.from_json/1","ref":"ExWebRTC.SessionDescription.html#from_json/1"},{"type":"type","doc":"","title":"ExWebRTC.SessionDescription.t/0","ref":"ExWebRTC.SessionDescription.html#t:t/0"},{"type":"function","doc":"","title":"ExWebRTC.SessionDescription.to_json/1","ref":"ExWebRTC.SessionDescription.html#to_json/1"},{"type":"module","doc":"Defines IVF Frame type.","title":"ExWebRTC.Media.IVF.Frame","ref":"ExWebRTC.Media.IVF.Frame.html"},{"type":"type","doc":"IVF Frame.\n\n`timestamp` is in `timebase_num`/`timebase_denum` seconds.\nFor more information see `ExWebRTC.Media.IVF.Header`.","title":"ExWebRTC.Media.IVF.Frame.t/0","ref":"ExWebRTC.Media.IVF.Frame.html#t:t/0"},{"type":"module","doc":"Defines IVF Frame Header type.","title":"ExWebRTC.Media.IVF.Header","ref":"ExWebRTC.Media.IVF.Header.html"},{"type":"type","doc":"IVF Frame Header.\n\nDescription of these fields is taken from:\nhttps://chromium.googlesource.com/chromium/src/media/+/master/filters/ivf_parser.h\n\n* `signature` - always \"DKIF\"\n* `version` - should be 0\n* `header_size` - size of header in bytes\n* `fourcc` - codec FourCC (e.g, 'VP80'). \nFor more information, see https://fourcc.org/codecs.php \n* `width` - width in pixels\n* `height` - height in pixels\n* `timebase_denum` - timebase denumerator\n* `timebase_num` - timebase numerator. For example, if\n`timebase_denum` is 30 and `timebase_num` is 2, the unit\nof `ExWebRTC.Media.IVFFrame`'s timestamp is 2/30 seconds.\n* `num_frames` - number of frames in a file\n* `unused` - unused","title":"ExWebRTC.Media.IVF.Header.t/0","ref":"ExWebRTC.Media.IVF.Header.html#t:t/0"},{"type":"module","doc":"Reads video frames from an IVF file.\n\nBased on:\n* https://formats.kaitai.io/vp8_ivf/\n* https://chromium.googlesource.com/chromium/src/media/+/refs/heads/main/filters/ivf_parser.cc","title":"ExWebRTC.Media.IVF.Reader","ref":"ExWebRTC.Media.IVF.Reader.html"},{"type":"function","doc":"Closes an IVF reader.\n\nWhen a process owning the IVF reader exits, IVF reader is closed automatically.","title":"ExWebRTC.Media.IVF.Reader.close/1","ref":"ExWebRTC.Media.IVF.Reader.html#close/1"},{"type":"function","doc":"Reads the next video frame from an IVF file.","title":"ExWebRTC.Media.IVF.Reader.next_frame/1","ref":"ExWebRTC.Media.IVF.Reader.html#next_frame/1"},{"type":"function","doc":"Opens an IVF file and reads its header.","title":"ExWebRTC.Media.IVF.Reader.open/1","ref":"ExWebRTC.Media.IVF.Reader.html#open/1"},{"type":"opaque","doc":"","title":"ExWebRTC.Media.IVF.Reader.t/0","ref":"ExWebRTC.Media.IVF.Reader.html#t:t/0"},{"type":"module","doc":"Writes video frames as an IVF file.","title":"ExWebRTC.Media.IVF.Writer","ref":"ExWebRTC.Media.IVF.Writer.html"},{"type":"function","doc":"Updates a number of frames in the header and closes the writer.\n\nIf a process owning an IVF writer exits, a file open by the IVF writer\nwill be closed automatically but header will not be updated.\nSee also `open/2` for more information on automatic header updates.","title":"ExWebRTC.Media.IVF.Writer.close/1","ref":"ExWebRTC.Media.IVF.Writer.html#close/1"},{"type":"function","doc":"Creates a new IVF writer.\n\nInitially, IVF header is written with `num_frames` and \nis updated every `num_frames` by `num_frames`.\nTo have a precise number of frames in the header,\neither write exactly `num_frames` or call `close/1` \nat the end of writing.","title":"ExWebRTC.Media.IVF.Writer.open/2","ref":"ExWebRTC.Media.IVF.Writer.html#open/2"},{"type":"opaque","doc":"","title":"ExWebRTC.Media.IVF.Writer.t/0","ref":"ExWebRTC.Media.IVF.Writer.html#t:t/0"},{"type":"function","doc":"Writes an IVF frame into a file.","title":"ExWebRTC.Media.IVF.Writer.write_frame/2","ref":"ExWebRTC.Media.IVF.Writer.html#write_frame/2"},{"type":"module","doc":"Reads Opus packets from an Ogg container file.\n\nFor now, works only with single Opus stream in the container.\n\nBased on:\n* [Xiph's official Ogg documentation](https://xiph.org/ogg/)\n* [RFC 7845: Ogg Encapsulation for the Opus Audio Codec](https://www.rfc-editor.org/rfc/rfc7845.txt)\n* [RFC 6716: Definition of the Opus Audio Codec](https://www.rfc-editor.org/rfc/rfc6716.txt)","title":"ExWebRTC.Media.Ogg.Reader","ref":"ExWebRTC.Media.Ogg.Reader.html"},{"type":"function","doc":"Closes an Ogg reader.\n\nWhen a process owning the Ogg reader exits, Ogg reader is closed automatically.","title":"ExWebRTC.Media.Ogg.Reader.close/1","ref":"ExWebRTC.Media.Ogg.Reader.html#close/1"},{"type":"function","doc":"Reads next Ogg packet.\n\nOne Ogg packet is equivalent to one Opus packet.\nThis function also returns the duration of the audio in milliseconds, based on Opus packet TOC sequence (see RFC 6716, sec. 3).\nIt assumes that all of the Ogg packets belong to the same stream.","title":"ExWebRTC.Media.Ogg.Reader.next_packet/1","ref":"ExWebRTC.Media.Ogg.Reader.html#next_packet/1"},{"type":"function","doc":"Opens Ogg file.\n\nFor now, works only with single Opus stream in the container.\nThis function reads the ID and Comment Headers (and, for now, ignores them).","title":"ExWebRTC.Media.Ogg.Reader.open/1","ref":"ExWebRTC.Media.Ogg.Reader.html#open/1"},{"type":"opaque","doc":"","title":"ExWebRTC.Media.Ogg.Reader.t/0","ref":"ExWebRTC.Media.Ogg.Reader.html#t:t/0"},{"type":"module","doc":"Writes Opus packets to an Ogg container file.\n\nFor now, works only with packets from a single Opus stream.\n\nBased on:\n* [Xiph's official Ogg documentation](https://xiph.org/ogg/)\n* [RFC 7845: Ogg Encapsulation for the Opus Audio Codec](https://www.rfc-editor.org/rfc/rfc7845.txt)\n* [RFC 6716: Definition of the Opus Audio Codec](https://www.rfc-editor.org/rfc/rfc6716.txt)","title":"ExWebRTC.Media.Ogg.Writer","ref":"ExWebRTC.Media.Ogg.Writer.html"},{"type":"function","doc":"Closes the writer.\n\nThis function MUST be called as it writes remaining, bufferd data to the Ogg file.","title":"ExWebRTC.Media.Ogg.Writer.close/1","ref":"ExWebRTC.Media.Ogg.Writer.html#close/1"},{"type":"function","doc":"Opens a new Ogg writer.\n\nThe writer MUST be closed with close/1,\notherwise some of the data might not be written to a file.","title":"ExWebRTC.Media.Ogg.Writer.open/2","ref":"ExWebRTC.Media.Ogg.Writer.html#open/2"},{"type":"opaque","doc":"","title":"ExWebRTC.Media.Ogg.Writer.t/0","ref":"ExWebRTC.Media.Ogg.Writer.html#t:t/0"},{"type":"function","doc":"Writes an Opus packet to the Ogg file.","title":"ExWebRTC.Media.Ogg.Writer.write_packet/2","ref":"ExWebRTC.Media.Ogg.Writer.html#write_packet/2"},{"type":"module","doc":"RTP depayloader.\n\nIt unpacks RTP packets into audio/video frames.","title":"ExWebRTC.RTP.Depayloader","ref":"ExWebRTC.RTP.Depayloader.html"},{"type":"function","doc":"Processes binary data from a single RTP packet, and outputs a frame if assembled.\n\nReturns the frame (or `nil` if a frame could not be depayloaded yet)\ntogether with the updated depayloader.","title":"ExWebRTC.RTP.Depayloader.depayload/2","ref":"ExWebRTC.RTP.Depayloader.html#depayload/2"},{"type":"opaque","doc":"","title":"ExWebRTC.RTP.Depayloader.depayloader/0","ref":"ExWebRTC.RTP.Depayloader.html#t:depayloader/0"},{"type":"function","doc":"Creates a new depayloader that matches the passed codec parameters.","title":"ExWebRTC.RTP.Depayloader.new/1","ref":"ExWebRTC.RTP.Depayloader.html#new/1"},{"type":"module","doc":"Utilities for RTP packets carrying H264 encoded payload.","title":"ExWebRTC.RTP.H264","ref":"ExWebRTC.RTP.H264.html"},{"type":"function","doc":"Returns a boolean telling if the packets contains a beginning of a H264 intra-frame.","title":"ExWebRTC.RTP.H264.keyframe?/1","ref":"ExWebRTC.RTP.H264.html#keyframe?/1"},{"type":"module","doc":"Buffers and reorders RTP packets based on `sequence_number`, introducing controlled latency\nin order to combat network jitter and improve the QoS.","title":"ExWebRTC.RTP.JitterBuffer","ref":"ExWebRTC.RTP.JitterBuffer.html"},{"type":"function","doc":"Flushes all remaining packets and resets the JitterBuffer.\n\nNote: After flushing, the rollover counter is reset to `0`.","title":"ExWebRTC.RTP.JitterBuffer.flush/1","ref":"ExWebRTC.RTP.JitterBuffer.html#flush/1"},{"type":"function","doc":"Handles the end of a previously set timer.","title":"ExWebRTC.RTP.JitterBuffer.handle_timeout/1","ref":"ExWebRTC.RTP.JitterBuffer.html#handle_timeout/1"},{"type":"function","doc":"Places a packet in the JitterBuffer.\n\nNote: The initial latency timer will be set after the first packet is inserted into the buffer.\nIf you want to start it at your own discretion, schedule a `handle_timeout/1` call prior to that.","title":"ExWebRTC.RTP.JitterBuffer.insert/2","ref":"ExWebRTC.RTP.JitterBuffer.html#insert/2"},{"type":"function","doc":"Creates a new `t:ExWebRTC.RTP.JitterBuffer.t/0`.","title":"ExWebRTC.RTP.JitterBuffer.new/1","ref":"ExWebRTC.RTP.JitterBuffer.html#new/1"},{"type":"type","doc":"Options that can be passed to `new/1`.\n\n* `latency` - latency introduced by the buffer, in milliseconds. `200` by default.","title":"ExWebRTC.RTP.JitterBuffer.options/0","ref":"ExWebRTC.RTP.JitterBuffer.html#t:options/0"},{"type":"type","doc":"The 3-element tuple returned by all functions other than `new/1`.\n\n* `packets` - a list with packets flushed from the buffer as a result of the function call. May be empty.\n* `timer_duration_ms` - see `t:timer/0`.\n* `buffer` - `t:ExWebRTC.RTP.JitterBuffer.t/0`.\n\nGenerally speaking, all results of this type can be handled in the same way.","title":"ExWebRTC.RTP.JitterBuffer.result/0","ref":"ExWebRTC.RTP.JitterBuffer.html#t:result/0"},{"type":"opaque","doc":"","title":"ExWebRTC.RTP.JitterBuffer.t/0","ref":"ExWebRTC.RTP.JitterBuffer.html#t:t/0"},{"type":"type","doc":"Time (in milliseconds) after which `handle_timeout/1` should be called.\nCan be `nil`, in which case no timer needs to be set.","title":"ExWebRTC.RTP.JitterBuffer.timer/0","ref":"ExWebRTC.RTP.JitterBuffer.html#t:timer/0"},{"type":"module","doc":"RTP Munger allows for converting RTP packet timestamps and sequence numbers\nto a common domain.\nIt also rewrites parts of the RTP payload that may require a similar behaviour.\n\nThis is useful when e.g. changing between Simulcast layers - the sender sends\nthree separate RTP streams (also called layers or encodings), but the receiver can receive only a\nsingle RTP stream.\n\n```\n# assume you receive two layers: \"h\" (high) and \"l\" (low)\n# and this is a GenServer\n\ndef init() do\n  {:ok, %{munger: Munger.new(:h264, 90_000), layer: \"h\"}}\nend\n\ndef handle_info({:ex_webrtc, _from, {:rtp, _id, rid, packet}}, state) do\n  if rid == state.layer do\n    {packet, munger} = Munger.munge(state.munger, packet)\n    send_packet_somewhere(packet)\n    {:noreply, %{state | munger: munger}}\n  else\n    {:noreply, state}\n  end\nend\n\ndef handle_info({:change_layer, layer}, state) do\n  # indicate to the munger that the next packet will be from a new layer\n  munger = Munger.update(state.munger)\n  {:noreply, %{munger: munger, layer: layer}\nend\n```","title":"ExWebRTC.RTP.Munger","ref":"ExWebRTC.RTP.Munger.html"},{"type":"function","doc":"Updates the RTP packet to match the common timestamp/sequence number domain.","title":"ExWebRTC.RTP.Munger.munge/2","ref":"ExWebRTC.RTP.Munger.html#munge/2"},{"type":"function","doc":"","title":"ExWebRTC.RTP.Munger.new/1","ref":"ExWebRTC.RTP.Munger.html#new/1"},{"type":"function","doc":"Creates a new `t:ExWebRTC.RTP.Munger.t/0`.\n\n`clock_rate` is the clock rate of the codec carried in munged RTP packets.","title":"ExWebRTC.RTP.Munger.new/2","ref":"ExWebRTC.RTP.Munger.html#new/2"},{"type":"opaque","doc":"","title":"ExWebRTC.RTP.Munger.t/0","ref":"ExWebRTC.RTP.Munger.html#t:t/0"},{"type":"function","doc":"Informs the munger that the next packet passed to `munge/2` will come\nfrom a different RTP stream.","title":"ExWebRTC.RTP.Munger.update/1","ref":"ExWebRTC.RTP.Munger.html#update/1"},{"type":"module","doc":"RTP payloader.\n\nIt packs audio/video frames into one or more RTP packets.","title":"ExWebRTC.RTP.Payloader","ref":"ExWebRTC.RTP.Payloader.html"},{"type":"function","doc":"Creates a new payloader that matches the passed codec parameters.\n\nOpts:\n  * max_payload_size - determines the maximum size of a single RTP packet outputted by the payloader.\n  It must be greater than `100`, and is set to `1000` by default.","title":"ExWebRTC.RTP.Payloader.new/2","ref":"ExWebRTC.RTP.Payloader.html#new/2"},{"type":"function","doc":"Packs a frame into one or more RTP packets.\n\nReturns the packets together with the updated payloader.","title":"ExWebRTC.RTP.Payloader.payload/2","ref":"ExWebRTC.RTP.Payloader.html#payload/2"},{"type":"opaque","doc":"","title":"ExWebRTC.RTP.Payloader.payloader/0","ref":"ExWebRTC.RTP.Payloader.html#t:payloader/0"},{"type":"module","doc":"Utilities for RTP packets carrying VP8 encoded payload.","title":"ExWebRTC.RTP.VP8","ref":"ExWebRTC.RTP.VP8.html"},{"type":"function","doc":"Checks whether RTP payload contains VP8 keyframe.","title":"ExWebRTC.RTP.VP8.keyframe?/1","ref":"ExWebRTC.RTP.VP8.html#keyframe?/1"},{"type":"extras","doc":"---\n\n**Elixir WebRTC** is an implementation of the [W3C WebRTC API](https://www.w3.org/TR/webrtc/) in the Elixir programming language.","title":"README","ref":"readme.html"},{"type":"extras","doc":"Add `ex_webrtc` to the list of dependencies in `mix.exs`\n\n```elixir\ndef deps do\n  [\n    {:ex_webrtc, \"~> 0.13.0\"}\n  ]\nend\n```\n\nElixir WebRTC comes with optional support for DataChannels, but it must be explicitely turned on by\nadding optional `ex_sctp` dependency\n\n```elixir\ndef deps do\n  [\n    {:ex_webrtc, \"~> 0.13.0\"},\n    {:ex_sctp, \"~> 0.1.0\"}\n  ]\nend\n```\n\nPlease note that `ex_sctp` requires you to have Rust installed in order to compile.","title":"Installation - README","ref":"readme.html#installation"},{"type":"extras","doc":"To get started with Elixir WebRTC, check out:\n* the [Introduction to Elixir Webrtc](https://hexdocs.pm/ex_webrtc/intro.html) tutorial\n* the [examples directory](https://github.com/elixir-webrtc/ex_webrtc/tree/master/examples) that contains a bunch of very simple usage examples of the library\n* the [`apps` repo](https://github.com/elixir-webrtc/apps) with example applications built on top of `ex_webrtc`\n* the [documentation](https://hexdocs.pm/ex_webrtc/readme.html), especially the [`PeerConnection` module page](https://hexdocs.pm/ex_webrtc/ExWebRTC.PeerConnection.html)\n* the [roadmap](https://github.com/elixir-webrtc/ex_webrtc/issues/28) to see what we are working on and how you can contribute\n\nIf you have any questions, ideas or topics to discuss about Elixir WebRTC, head to the [discussions page](https://github.com/orgs/elixir-webrtc/discussions).","title":"Getting started - README","ref":"readme.html#getting-started"},{"type":"extras","doc":"Elixir WebRTC is the W3C WebRTC standard implementation written in almost pure Elixir.\nIt does not use Membrane under the hood, and it aims to be as close to the W3C (and hence JavaScript) API as possible.\n\nMembrane, on the other hand, is a multimedia framework. It supports a lot of different protocols, codecs and containers.\nMembrane uses Elixir WebRTC in its [membrane_webrtc_plugin](https://github.com/membraneframework/membrane_webrtc_plugin) making it possible to use WebRTC with other Membrane elements.","title":"Elixir WebRTC vs Membrane - README","ref":"readme.html#elixir-webrtc-vs-membrane"},{"type":"extras","doc":"Elixir WebRTC is created by [Software Mansion](https://swmansion.com/).\n\nSince 2012 Software Mansion is a software agency with experience in building web and mobile apps as well as complex multimedia solutions. We are Core React Native Contributors and experts in live streaming and broadcasting technologies. We can help you build your next dream product – [Hire us](https://swmansion.com/contact/projects).\n\n[![swm](https://logo.swmansion.com/logo?color=white&variant=desktop&width=150 'Software Mansion')](https://swmansion.com)","title":"Credits - README","ref":"readme.html#credits"},{"type":"extras","doc":"# Introduction to WebRTC\n\nIn this series of tutorials, we are going to learn what is WebRTC, and go through some simple use cases of Elixir WebRTC.\nIts purpose is to teach you where you'd want to use WebRTC, show you what the WebRTC API looks like, and how it should\nbe used, focusing on some common caveats.\n\n> #### Before You Start {: .info}\n> This guide assumes little prior knowledge of the WebRTC API, but it would be highly beneficial\n> to go through the [MDN WebRTC tutorial](https://developer.mozilla.org/en-US/docs/Web/API/WebRTC_API)\n> as the Elixir API tries to closely mimic the browser JavaScript API.","title":"Introduction to WebRTC","ref":"intro.html"},{"type":"extras","doc":"WebRTC is an open, real-time communication standard that allows you to send video, audio, and generic data between peers over the network.\nIt places a lot of emphasis on low latency (targeting values in low hundreds of milliseconds end-to-end) and was designed to be used peer-to-peer.\n\nWebRTC is implemented by all of the major web browsers and is available as a JavaScript API, there's also native WebRTC clients for Android and iOS\nand implementation in other programming languages ([Pion](https://github.com/pion/webrtc), [webrtc.rs](https://github.com/webrtc-rs/webrtc),\nand now [Elixir WebRTC](https://github.com/elixir-webrtc/ex_webrtc)).","title":"What is WebRTC - Introduction to WebRTC","ref":"intro.html#what-is-webrtc"},{"type":"extras","doc":"WebRTC is the obvious choice in applications where low latency is important. It's also probably the easiest way to obtain the voice and video from a user of\nyour web application. Here are some example use cases:\n\n* videoconferencing apps (one-on-one meetings of fully fledged meeting rooms, like Microsoft Teams or Google Meet)\n* ingress for broadcasting services (as a presenter, you can use WebRTC to get media to a server, which will then broadcast it to viewers using WebRTC or different protocols)\n* obtaining voice and video from web app users to use it for machine learning model inference on the back end.\n\nIn general, all of the use cases come down to getting media from one peer to another. In the case of Elixir WebRTC, one of the peers is usually a server,\nlike your Phoenix app (although it doesn't have to - there's no concept of server/client in WebRTC, so you might as well connect two browsers or two Elixir peers).\n\nThis is what the next tutorials will focus on - we will try to get media from a web browser to a simple Elixir app.","title":"Where would you use WebRTC - Introduction to WebRTC","ref":"intro.html#where-would-you-use-webrtc"},{"type":"extras","doc":"# Negotiating the connection\n\nBefore starting to send or receive media, you need to negotiate the WebRTC connection first, which comes down to:\n\n1. Specifying to your WebRTC peer what you want to send and/or receive (like video or audio tracks).\n2. Exchanging information necessary to establish a connection with the other WebRTC peer.\n3. Starting the data transmission.\n\nWe'll go through this process step-by-step.\n\n> #### Code snippets {: .warning}\n> These tutorials include code snippetes showing how your implementation _might_ look like.\n> For comprehensive, working examples take a look at the [examples](https://github.com/elixir-webrtc/ex_webrtc/tree/master/examples)\n> in the `ex_webrtc` repository.","title":"Negotiating the connection","ref":"negotiation.html"},{"type":"extras","doc":"Let's start from the web browser JavaScript code. We will try to send the video from your webcam and audio from your microphone to the Elixir app.\n\nFirstly, we'll create a new `RTCPeerConnection` - this object represents a WebRTC connection with a remote peer. Further on, it will be our interface to all\nof the WebRTC-related stuff.\n\n```js\n// `iceServers` option will be explained at the end of this tutorial\nconst pc = new RTCPeerConnection({ iceServers: \"stun:stun.l.google.com:19302\" })\n```\n\nNext, we will obtain the media tracks from the webcam and microphone using `mediaDevices` JavaScript API.\n\n```js\n// a popup asking for permissions should appear after calling this function\nconst localStream = await navigator.mediaDevices.getUserMedia({ audio: true, video: true });\n```\n\nThe `localStream` is an object of type `MediaStream` - it aggregates video or audio tracks.\nNow we can add the tracks to our `RTCPeerConnection`.\n\n```js\nfor (const track of localStream.getTracks()) {\n  pc.addTrack(track, localStream);\n}\n```\n\nFinally, we have to create and set an offer.\n\n```js\nconst offer = await pc.createOffer();\n// offer == { type: \"offer\", sdp: \" \"}\nawait pc.setLocalDescription(offer);\n```\n\nFinally, we have to create and set an offer.\nIt will contain information on how many tracks we want to send, which codecs we want to use, whether we are willing to also receive something or not and so on.\nThe other side responds with an answer, which can either accept, reject or partially accept our offer (e.g. accept only audio tracks).\nBoth offer and answer are carried in a text format called SDP. You can read more about it in the [SDP Anatomy](https://webrtchacks.com/sdp-anatomy/) tutorial from _webrtcHacks_.\n\nNext, we need to pass the offer to the other peer - in our case, the Elixir app. The WebRTC standard does not specify how to do this.\nHere, we will just assume that the offer was sent to the Elixir app using some kind of WebSocket relay service that we previously connected to, but generally it\ndoesn't matter how you get the offer from one peer to the other.\n\n```js\nconst json = JSON.stringify(offer);\nwebSocket.send_offer(json);\n```\n\nLet's handle the offer in the Elixir app next.\n\n> #### PeerConnection configuration {: .info}\n> There is quite a lot of configuration options for the `ExWebRTC.PeerConnection`.\n> You can find all of them in `ExWebRTC.PeerConnection.Configuration` module docs. For instance, all of the JavaScript `RTCPeerConnection` events\n> like `track` or `icecandidate` in Elixir WebRTC are simply messages sent by the `ExWebRTC.PeerConnection` process sent to the process that\n> called `ExWebRTC.PeerConnection.start_link/2` by default. This can be changed by using the `start_link(controlling_process: pid)` option!\n\nBefore we do anything else, we need to set up the `PeerConnection`, similar to what we have done in the web browser. The main difference\nbetween Elixir and JavaScript WebRTC API is that, in Elixir, `PeerConnection` is a process.\n\n```elixir\n# PeerConnection in Elixir WebRTC is a process!\n# take a look at the very end of the tutorial to learn what `ice_servers` option is\n{:ok, pc} = ExWebRTC.PeerConnection.start_link(ice_servers: [%{urls: \"stun:stun.l.google.com:19302\"}])\n ```\n\nThen we can handle the SDP offer that was sent from the web browser.\n\n```elixir\n# we will use the Jason library for decoding the JSON message\nreceive do\n  {:web_socket, {:offer, json}} ->\n    offer =\n      json\n      |> Jason.decode!()\n      |> ExWebRTC.SessionDescription.from_json()\n\n    ExWebRTC.PeerConnection.set_remote_description(pc, offer)\nend\n```\n\n> #### Is WebRTC peer-to-peer? {: .info}\n> WebRTC itself is peer-to-peer. It means that the audio and video data is sent directly from one peer to another.\n> But to even establish the connection itself, we need to somehow pass the offer and answer between the peers.\n>\n> In our case, the Elixir app (e.g. a Phoenix web app) probably has a public-facing IP address - we can send the offer directly to it.\n> In the case when we want to connect two web browser WebRTC peers, a relay service might be needed to pass the offer and answer -\n> after all, both of the peers might be in private networks, like your home WiFi.\n\nNow we create the answer, set it, and send it back to the web browser.\n\n```elixir\n{:ok, answer} = ExWebRTC.PeerConnection.create_answer(pc)\n:ok = PeerConnection.set_local_description(pc, answer)\n\nanswer\n|> ExWebRTC.SessionDescription.to_json()\n|> Jason.encode!()\n|> web_socket_send_answer()\n```\n\nNow the `PeerConnection` process should send messages to its parent process announcing remote tracks - each of the messages maps to\none of the tracks added on the JavaScript side.\n\n```elixir\nreceive do\n  {:ex_webrtc, ^pc, {:track, %ExWebRTC.MediaStreamTrack{}}} ->\n    # we will learn what you can do with the track in the next tutorial\nend\n```\n\n> #### PeerConnection can be bidirectional {: .tip}\n> Here we have only shown you how to receive data from a browser in the Elixir app, but, of course, you\n> can also send data from Elixir's `PeerConnection` to the browser.\n>\n> Just be aware of this for now, you will learn more about sending data using Elixir WebRTC in the next tutorial.\n\n\nLastly, we need to set the answer in the web browser.\n\n```js\nanswer = JSON.parse(receive_answer());\nawait pc.setRemoteDescription(answer);\n```\n\nThe process of the offer/answer exchange is called _negotiation_. Here, we've just presented the very first negotiation, but\nthe process has to be repeated every time tracks are added or removed. You can learn\nabout negotiation in more complex secenarios in [Modifying the session](./../advanced/modifying.md).","title":"Offer and answer exchange - Negotiating the connection","ref":"negotiation.html#offer-and-answer-exchange"},{"type":"extras","doc":"ICE is a protocol used by WebRTC to establish peer-to-peer connection. It works by exchanging something called _ICE candidates_\nbetween the peers using some kind of separate medium (similar to the offer/answer exchange). These candidates, simplifying a bit, contain IP addreses that other\npeer will try to use to connect to your machine. ICE will try to find a pair of these addresse (one for each peer) and establish a connection.\n\n> #### Why candidates are not in the offer/answer? {: .info}\n> ICE candidates can be included in the offer or the answer, but generally they are not - you send them separately.\n> Gathering a candidate can be anywhere in-between of nearly instantenous, or taking up to a few seconds, depending on the type of the candidate.\n> The PeerConnection will asynchornously produce the \"quicker\" candidates so you can send them to the other peer and try to establish\n> a connection as quickly as possible. If any of the later candidates happens to be more suitable (or the previous did not succeed), PeerConnection will use it instead.\n\nThe PeerConnection will gather these candidates, but it is your responsibility (similarly to offer/answer exchange, again) to send them to the other peer.\n\nIn JavaScript:\n\n```js\n// the end of candidates will be signalled by event.candidate === null\npc.onicecandidate = event => webSocket.send_ice_candidate(JSON.stringify(event.candidate));\nwebSocket.onIceCandidate = candidate => pc.addIceCandidate(JSON.parse(candidate));\n```\n\nAnd in Elixir:\n\n```elixir\nreceive do\n  {:ex_webrtc, ^pc, {:ice_candidate, candidate}} ->\n    candidate\n      |> ExWebRTC.ICECandidate.to_json()\n      |> Jason.encode!()\n      |> web_socket_send_ice_candidate()\n\n  {:web_socket, {:ice_candidate, json}} ->\n    candidate =\n      json\n      |> Jason.decode!()\n      |> ExWebRTC.ICECandidate.from_json()\n\n      ExWebRTC.PeerConnection.add_ice_candidate(pc, candidate)\nend\n```\n\nAfter the candidate exchange, the connection should be eventually established and media will start to flow!\nYou can tell it by listening for `{:ex_webrtc, _from, {:connection_state_change, :connected}}` message\nor by handling the `onconnectionstatechange` event on the JavaScript `RTCPeerConnection`.\n\n> #### ICE servers {: .info}\n> Remember when we created the `RTCPeerConnection` object at the beginning of this tutorial? It was configured\nwith `iceServers` options:\n>\n> ```js\n> const pc = new RTCPeerConnection({ iceServers: \"stun:stun.l.google.com:19302\" })\n> ```\n>\n> It is a list of STUN/TURN servers that the PeerConnection will try to use.\n> These are used by the PeerConnection to generate more ICE candidates with different types, which vastly\n> increases chances of establishing a connection between peers in some specific cases.\n> You can read more about it in the [MDN docs](https://developer.mozilla.org/en-US/docs/Web/API/RTCPeerConnection/RTCPeerConnection).\n\nYou might be wondering how can you do something with the media data in the Elixir app.\nWhile in JavaScript API you are limited to e.g. attaching tracks to video elements on a web page,\nElixir WebRTC provides you with the actual media data sent by the other peer in the form\nof RTP packets for further processing. You will learn how to tackle this in the next part of this tutorial series.","title":"ICE and candidate exchange - Negotiating the connection","ref":"negotiation.html#ice-and-candidate-exchange"},{"type":"extras","doc":"# Forwarding media data\n\nElixir WebRTC, in contrast to the JavaScript API, provides you with the actual media data transmitted via WebRTC.\nThat means you can be much more flexible with what you do with the data, but you also need to know a bit more\nabout how WebRTC actually works under the hood.\n\nAll of the media data received by the `PeerConnection` is sent to the user in the form of messages like this:\n\n```elixir\nreceive do\n  {:ex_webrtc, ^pc, {:rtp, track_id, _rid, packet}} ->\n    # do something with the packet\n    # also, for now, you can assume that _rid is always nil and ignore it\nend\n```\n\nThe `track_id` corresponds to one of the tracks that we received in `{:ex_webrtc, _from, {:track, %MediaStreamTrack{id: track_id}}}` messages.\nThe `packet` is an RTP packet. It contains the media data alongside some other useful information.\n\n> #### The RTP protocol {: .info}\n> RTP is a network protocol created for carrying real-time data (like media) and is used by WebRTC.\n> It provides some useful features like:\n>\n> * sequence numbers: UDP (which is usually used by WebRTC) does not provide packet ordering, thus we need this to catch missing or out-of-order packets\n> * timestamp: these can be used to correctly play the media back to the user (e.g. using the right framerate for the video)\n> * payload type: thanks to this combined with information in the SDP offer/answer, we can tell which codec is carried by this packet\n>\n> and many more. Check out the [RFC 3550](https://datatracker.ietf.org/doc/html/rfc3550) to learn more about RTP.\n\nNext, we will learn what you can do with the RTP packets.\nFor now, we won't actually look into the packets themselves, our goal for this part of the tutorial will be to forward the received data back to the same web browser.\n\n```mermaid\nflowchart LR\n  subgraph Elixir\n    PC[PeerConnection] --> Forwarder --> PC\n  end\n\n  WB((Web Browser)) <-.-> PC\n```\n\nThe only thing we have to implement is the `Forwarder` process. In practice, making it a `GenServer` would be probably the\neasiest and that's what we are going to do here. Let's combine the ideas from the previous section to write it.\n\n```elixir\ndef init(_) do\n  {:ok, pc} = PeerConnection.start_link(ice_servers: [%{urls: \"stun:stun.l.google.com:19302\"}])\n\n  # we expect to receive two tracks from the web browser - audio and video\n  # so we also need to add two tracks here, we will use them to loop media back to the other browser\n  # from each of the web browser tracks\n  stream_id = MediaStreamTrack.generate_stream_id()\n  audio_track = MediaStreamTrack.new(:audio, [stream_id])\n  video_track = MediaStreamTrack.new(:video, [stream_id])\n\n  {:ok, _sender} = PeerConnection.add_track(pc, audio_track)\n  {:ok, _sender} = PeerConnection.add_track(pc, video_track)\n\n  # in_tracks (tracks we will receive from the browser) = %{id => kind}\n  # out_tracks (tracks we will send to the browser) = %{kind => id}\n  in_tracks = %{}\n  out_tracks = %{audio: audio_track.id, video: video_track.id}\n  {:ok, %{pc: pc, out_tracks: out_tracks, in_tracks: in_tracks}}\nend\n```\n\nWe started by creating the PeerConnection and adding two tracks (one for audio and one for video).\nRemember that these tracks will be used to *send* data to the web browser peer. Remote tracks (the ones we will set up on the JavaScript side, like in the previous tutorial)\nwill arrive as messages after the negotiation is completed.\n\n> #### What are the tracks? {: .tip}\n> In the context of Elixir WebRTC, a track is simply a _track id_, _ids_ of streams this track belongs to, and a _kind_ (audio/video).\n> We can either add tracks to the PeerConnection (these tracks will be used to *send* data when calling `PeerConnection.send_rtp/4` and\n> for each one of the tracks, the remote peer should fire the `track` event)\n> or handle remote tracks (which you are notified about with messages from the PeerConnection process: `{:ex_webrtc, _from, {:track, track}}`).\n> These are used when handling messages with RTP packets: `{:ex_webrtc, _from, {:rtp, _rid, track_id, packet}}`.\n> You cannot use the same track to send AND receive, keep that in mind.\n>\n> Alternatively, all of the tracks can be obtained by iterating over the transceivers:\n>\n> ```elixir\n> tracks =\n>   peer_connection\n>   |> PeerConnection.get_transceivers()\n>   |> Enum.map(&(&1.receiver.track))\n> ```\n>\n> If you want to know more about transceivers, read the [Mastering Transceivers](https://hexdocs.pm/ex_webrtc/mastering_transceivers.html) guide.\n\nNext, we need to take care of the offer/answer and ICE candidate exchange. This can be done the exact same way as in the previous\ntutorial, so we won't get into here.\n\nAfter the negotiation, we can expect to receive messages with notifications about new remote tracks.\nLet's handle these and match them with the tracks that we are going to send to.\nWe need to be careful not to send packets from the audio track on a video track by mistake!\n\n```elixir\ndef handle_info({:ex_webrtc, _from, {:track, track}}, state) do\n  state = put_in(state.in_tracks[track.id], track.kind)\n  {:noreply, state}\nend\n```\n\nWe are ready to handle the incoming RTP packets!\n\n```elixir\ndef handle_info({:ex_webrtc, _from, {:rtp, track_id, nil, packet}}, state) do\n  kind = Map.fetch!(state.in_tracks, track_id)\n  id = Map.fetch!(state.out_tracks, kind)\n  :ok = PeerConnection.send_rtp(state.pc, id, packet)\n\n  {:noreply, state}\nend\n```\n\n> #### RTP packet rewriting {: .info}\n> In the example above we just receive the RTP packet and immediately send it back. In reality, a lot of stuff in the packet header must be rewritten.\n> That includes SSRC (a number that identifies to which stream the packet belongs), payload type (indicates the codec, even though the codec does not\n> change between two tracks, the payload types are dynamically assigned and may differ between RTP sessions), and some RTP header extensions. All of that is\n> done by Elixir WebRTC behind the scenes, but be aware - it is not as simple as forwarding the same piece of data!\n\nLastly, let's take care of the client-side code. It's nearly identical to what we have written in the previous tutorial,\nexcept for the fact that we need to handle tracks added by the Elixir's PeerConnection.\n\n```js\n// these will be the tracks that we added using `PeerConnection.add_track` in Elixir\n// but be careful! event for the same track, the ids might be different for each of the peers\npc.ontrack = event => videoPlayer.srcObject = event.stream[0];\n```\n\nAnd that's it! The other peer should be able to see and hear the echoed video and audio.\n\n> #### PeerConnection state {: .info}\n> Before we can send anything on a PeerConnection, its state must change to `connected` which is signaled\n> by the `{:ex_webrtc, _from, {:connection_state_change, :connected}}` message. In this particular example, we want\n> to send packets on the very same PeerConnection that we received the packets from, thus it must be connected\n> from the first RTP packet received.\n\nWhat you've seen here is a simplified version of the [echo](https://github.com/elixir-webrtc/ex_webrtc/tree/master/examples/echo) example available\nin the Elixir WebRTC Github repo. Check it out and play with it!\n\nNow, you might be thinking that forwarding the media back to the same web browser does not seem very useful, and you're probably right!\nBut thankfully, you can use the gained knowledge to build more complex apps.\n\nIn the next part of the tutorial, we will learn how to actually do something with media data in the Elixir app.","title":"Forwarding media data","ref":"forwarding.html"},{"type":"extras","doc":"# Consuming media data\n\nOther than just forwarding, we would like to be able to use the media right in the Elixir app to e.g.\nuse it as a machine learning model input, or create a recording of a meeting.\n\nIn this tutorial, we are going to learn how to use received media as input for ML inference.","title":"Consuming media data","ref":"consuming.html"},{"type":"extras","doc":"When the browser sends audio or video, it does the following things:\n\n1. Capturing the media from your peripheral devices, like a webcam or microphone.\n2. Encoding the media, so it takes less space and uses less network bandwidth.\n3. Packing it into a single or multiple RTP packets, depending on the media chunk (e.g., video frame) size.\n4. Sending it to the other peer using WebRTC.\n\nWe have to reverse these steps in order to be able to use the media:\n\n1. We receive the media from WebRTC.\n2. We unpack the encoded media from RTP packets.\n3. We decode the media to a raw format.\n4. We use the media however we like.\n\nWe already know how to do step 1 from previous tutorials, and step 4 is completely up to the user, so let's go through steps 2 and 3 in the next sections.\n\n> #### Codecs {: .info}\n> A media codec is a program/technique used to encode/decode digital video and audio streams. Codecs also compress the media data,\n> otherwise, it would be too big to send over the network (bitrate of raw 24-bit color depth, FullHD, 60 fps video is about 3 Gbit/s!).\n>\n> In WebRTC, most likely you will encounter VP8, H264 or AV1 video codecs and Opus audio codec. Codecs used during the session are negotiated in\n> the SDP offer/answer exchange. You can tell what codec is carried in an RTP packet by inspecting its payload type (`payload_type` field in the case of Elixir WebRTC).\n> This value should correspond to one of the codecs included in the SDP offer/answer.","title":"From raw media to RTP - Consuming media data","ref":"consuming.html#from-raw-media-to-rtp"},{"type":"extras","doc":"We refer to the process of getting the media payload out of RTP packets as _depayloading_. Usually a single video frame is split into\nmultiple RTP packets, and in case of audio, each packet carries, more or less, 20 milliseconds of sound. Fortunately, you don't have to worry about this,\njust use one of the depayloaders provided by Elixir WebRTC (see the `ExWebRTC.RTP. ` submodules). For instance, when receiving VP8 RTP packets, we could depayload\nthe video by doing:\n\n```elixir\ndef init(_) do\n  # ...\n  state = %{depayloader: ExWebRTC.Media.VP8.Depayloader.new()}\n  {:ok, state}\nend\n\ndef handle_info({:ex_webrtc, _from, {:rtp, _track_id, nil, packet}}, state) do\n  depayloader =\n    case ExWebRTC.RTP.VP8.Depayloader.write(state.depayloader, packet) do\n      {:ok, depayloader} -> depayloader\n      {:ok, frame, depayloader} ->\n        # we collected a whole frame (it is just a binary)!\n        # we will learn what to do with it in a moment\n        depayloader\n    end\n\n  {:noreply, %{state | depayloader: depayloader}}\nend\n```\n\nEvery time we collect a whole video frame consisting of a bunch of RTP packets, the `VP8.Depayloader.write` returns it for further processing.\n\n> #### Codec configuration {: .warning}\n> By default, `ExWebRTC.PeerConnection` will use a set of default codecs when negotiating the connection. In such case, you have to either:\n>\n> * support depayloading/decoding for all of the negotiated codecs\n> * force some specific set of codecs (or even a single codec) in the `PeerConnection` configuration.\n>\n> Of course, the second option is much simpler, but it increases the risk of failing the negotiation, as the other peer might not support your codec of choice.\n> If you still want to do it the simple way, set the codecs in `PeerConnection.start_link`\n> ```elixir\n> codec = %ExWebRTC.RTPCodecParameters{\n>     payload_type: 96,\n>     mime_type: \"video/VP8\",\n>     clock_rate: 90_000\n> }\n> {:ok, pc} = ExWebRTC.PeerConnection.start_link(video_codecs: [codec])\n> ```\n> This way, you either will always have to send/receive VP8 video codec, or you won't be able to negotiate a video stream at all. At least you won't encounter\n> unpleasant bugs in video decoding!","title":"Depayloading RTP - Consuming media data","ref":"consuming.html#depayloading-rtp"},{"type":"extras","doc":"Before we use the video as an input to the machine learning model, we need to decode it into raw format. Video decoding or encoding is a very\ncomplex and resource-heavy process, so we don't provide anything for that in Elixir WebRTC, but you can use the `xav` library, a simple wrapper over `ffmpeg`,\nto decode the VP8 video. Let's modify the snippet from the previous section to do so.\n\n```elixir\ndef init(_) do\n  # ...\n  serving = # setup your machine learning model (i.e. using Bumblebee)\n  state = %{\n    depayloader: ExWebRTC.Media.VP8.Depayloader.new(),\n    decoder: Xav.Decoder.new(:vp8),\n    serving: serving\n  }\n  {:ok, state}\nend\n\ndef handle_info({:ex_webrtc, _from, {:rtp, _track_id, nil, packet}}, state) do\n  depayloader =\n    with {:ok, frame, depayloader} <- ExWebRTC.RTP.VP8.Depayloader.write(state.depayloader, packet),\n         {:ok, raw_frame} <- Xav.Decoder.decode(state.decoder, frame) do\n      # raw frame is just a 3D matrix with the shape of resolution x colors (e.g 1920 x 1080 x 3 for FullHD, RGB frame)\n      # we can cast it to Elixir Nx tensor and use it as the machine learning model input\n      # machine learning stuff is out of scope of this tutorial, but you probably want to check out Elixir Nx and friends\n      tensor = Xav.Frame.to_nx(raw_frame)\n      prediction = Nx.Serving.run(state.serving, tensor)\n      # do something with the prediction\n\n      depayloader\n    else\n      {:ok, depayloader} -> depayloader\n      {:error, _err} -> # handle the error\n    end\n\n  {:noreply, %{state | depayloader: depayloader}}\nend\n```\n\nWe decoded the video and used it as an input of the machine learning model and got some kind of prediction - do whatever you want with it.\n\n> #### Jitter buffer {: .warning}\n> Do you recall that WebRTC uses UDP under the hood, and UDP does not ensure packet ordering? We could ignore this fact when forwarding the packets (as\n> it was not our job to decode/play/save the media), but now packets out of order can seriously mess up the process of decoding.\n> To remedy this issue, something called _jitter buffer_ can be used. Its basic function\n> is to delay/buffer incoming packets by some time, let's say 100 milliseconds, waiting for the packets that might be late. Only if the packets do not arrive after the\n> additional 100 milliseconds, we count them as lost. To learn more about jitter buffer, read [this](https://bloggeek.me/webrtcglossary/jitter-buffer/).\n>\n> As of now, Elixir WebRTC does not provide a jitter buffer, so you either have to build something yourself or wish that such issues won't occur, but if anything\n> is wrong with the decoded video, this might be the problem.\n\nThis tutorial shows, more or less, what the [Recognizer](https://github.com/elixir-webrtc/apps/tree/master/recognizer) app does. Check it out, along with other\nexample apps in the [apps](https://github.com/elixir-webrtc/apps) repository, it's a great reference on how to implement fully-fledged apps based on Elixir WebRTC.","title":"Decoding the media to raw format - Consuming media data","ref":"consuming.html#decoding-the-media-to-raw-format"},{"type":"extras","doc":"# Simulcast\n\nSimulcast is a technique where a client sends multiple encodings of the same video to the server, which is then responsible for dynamically choosing the appropraite encoding for every peer (other client).\nEncodings differ between each other in resolution and/or frame rate.\nThe selection of the encoding is based on:\n* Receiver available bandwidth.\n* Receiver preferences (e.g. explicit request to receive video at HD resolution instead of FHD).\n* UI layout (e.g. videos displayed in smaller tiles will be sent at a lower resolution).\n\nSimulcast is not utilized in direct client-client connections (no intermediate server) because in such cases, \nthe sender can adjust its resolution or frame rate based on a feedback from the receiver.\n\nElixir WebRTC comes with:\n* Support for inbound simulcast - it allows to receive multiple incoming resolutions\n* RTP munger and keyframe detectors, which can be used for implementing encoding switching on the server side\n\nCurrently there is no support for:\n* Outbound simulcast\n* Bandwidth estimation\n* Automatic encoding switching\n\n```mermaid\nflowchart LR\n  WB1((Web Browser1)) -->|low| Server\n  WB1((Web Browser1)) -->|medium| Server\n  WB1((Web Browser1)) -->|high| Server\n  Server -->|low| WB2((WebBrowser 2))\n  Server -->|high| WB3((WebBrowser 3))\n```","title":"Simulcast","ref":"simulcast.html"},{"type":"extras","doc":"","title":"Turning simulcast on - Simulcast","ref":"simulcast.html#turning-simulcast-on"},{"type":"extras","doc":"Elixir WebRTC automatically accepts incoming simulcast tracks so there are no extra steps required.","title":"Elixir WebRTC - Simulcast","ref":"simulcast.html#elixir-webrtc"},{"type":"extras","doc":"Simulcast can be enabled when adding a new track. For example:\n\n```js\nconst pc = new RTCPeerConnection();\n\nconst localStream = await navigator.mediaDevices.getUserMedia({\n  video: {\n    width: { ideal: 1280 },\n    height: { ideal: 720 },\n  },\n});\n\npc.addTransceiver(localStream.getVideoTracks()[0], {\n  streams: [localStream],\n  sendEncodings: [\n    { rid: 'h', maxBitrate: 1500 * 1024 },\n    { rid: 'm', scaleResolutionDownBy: 2, maxBitrate: 600 * 1024 },\n    { rid: 'l', scaleResolutionDownBy: 4, maxBitrate: 300 * 1024 },\n  ],\n});\n```\n\n> #### Minimal starting resolution {: .warning}\n> To run 3 simulcast encodings, the minimal starting resolution\n> must be 960x540. See more [here](https://source.chromium.org/chromium/chromium/src/+/main:third_party/webrtc/video/config/simulcast.cc;l=79?q=simulcast.cc).","title":"JavaScript - Simulcast","ref":"simulcast.html#javascript"},{"type":"extras","doc":"When simulcast is enabled, packets are labeled with an `rid`, which denotes simulcast\nencoding that a packet belongs to:\n\n```elixir\n{:ex_webrtc, input_pc_pid, {:rtp, input_track_id, rid, packet}}\n```","title":"Receiving simulcast packets - Simulcast","ref":"simulcast.html#receiving-simulcast-packets"},{"type":"extras","doc":"Switching between simulcast encodings requires some modifications to RTP packets.\nEvery encoding starts with a random RTP sequence number and a random RTP timestamp.\nBecause client that receives our stream is never aware of simulcast (they always receive\na single encoding), we have to rewrite those sequence numbers and timestamps to be continuous and increasing.\nThis process is known as munging.\n\n1. Create munger with codec sample rate\n\n```elixir\nalias ExWebRTC.PeerConnection\nalias ExWebRTC.RTP.{H264, Munger}\n\nm = Munger.new(:h264, 90_000)\n```\n\n2. When a packet from an encoding that we want to forward arrives, rewrite its sequnce number and timestamp:\n\n```elixir\nreceive do\n  {:ex_webrtc, input_pc, {:rtp, _input_track_id, \"m\", packet}} ->\n    {packet, munger} = Munger.munge(munger, packet)\n    :ok = PeerConnection.send_rtp(output_pc, output_track_id, packet)\n  {:ex_webrtc, input_pc, {:rtp, _input_track_id, _rid, packet}} ->\n    # ignore other packets\nend\n```\n\n3. To switch to another encoding, request a keyframe for this encoding.\nOnce the keyframe arrives, update the munger and start forwarding new packets.\nFor example, transitioning from encoding `m` to `h`:\n\n\n```elixir\n# assume we have the following state\nstate = %{\n  current_encoding: \"m\", \n  munger: munger, \n  input_pc: input_pc,\n  input_track_id: input_track_id,\n  output_pc: output_pc, \n  output_track_id: output_track_id\n}\n\n:ok = PeerConnection.send_pli(state.input_pc, state.input_track_id, \"h\")\n\n# ...\n\nreceive do\n  {:ex_webrtc, input_pc, {:rtp, _input_track_id, rid, packet}} ->\n    cond  do\n      rid == state.current_encoding -> \n        {munger, packet} = Munger.munge(munger, packet)\n        :ok = PeerConnection.send_rtp(state.output_pc, state.output_track_id, packet)\n        %{state | munger: munger}\n      rid == \"h\" and H264.keyframe?(packet) ->\n        munger = Munger.update(munger)\n        {munger, packet} = Munger.munge(munger, packet)\n        :ok = PeerConnection.send_rtp(state.output_pc, state.output_track_id, packet)\n        %{state | munger: munger, current_encoding: \"h\"}\n      true ->\n        state\n    end\nend\n```\n\nSee our [Broadcaster](https://github.com/elixir-webrtc/apps/blob/master/broadcaster/lib/broadcaster/forwarder.ex) app source code for more.","title":"Switching between simulcast encodings - Simulcast","ref":"simulcast.html#switching-between-simulcast-encodings"},{"type":"extras","doc":"# Modifying the session\n\nIn the introductory tutorials we focused on forwarding the data back to the same peer. Usually, you want to connect with multiple peers, which means adding\nmore PeerConnection to the Elixir app, like in the diagram below.\n\n```mermaid\nflowchart BR\n  subgraph Elixir\n    PC1[PeerConnection 1] <--> Forwarder <--> PC2[PeerConnection 2]\n    Forwarder <--> PC3[PeerConnection 3]\n  end\n\n  WB1((Web Browser 1)) <-.-> PC1\n  WB2((Web Browser 2)) <-.-> PC2\n  WB3((Web Browser 3)) <-.-> PC3\n```\n\nIn this scenario, we just forward packets from one peer to the other one (or even a bunch of other peers). This is a bit more challenging for a bunch of reasons:","title":"Modifying the session","ref":"modifying.html"},{"type":"extras","doc":"You need to decide who starts the negotiation for every PeerConnection created - it can be either the client/web browser (so the case we went through\nin the previous sections), the server, or both depending on when the peer joined. Also, don't forget that after you add or remove tracks from a PeerConnection,\nnew negotiation has to take place!\n\n> #### The caveats of negotiation {: .tip}\n> But wait, the peer who added new tracks doesn't have to start the negotiation?\n>\n> Certainly, that's the simplest way, but as long as the *number of transceivers* of the offerer (or, to be specific, the number of m-lines in the offer SDP with the appropriate\n> `direction` attribute set) is greater or equal to the number of all tracks added by the answerer, the tracks will be considered in the negotiation.\n>\n> But what does that even mean?\n> Each transceiver is responsible for sending and/or receiving a single track. When you call `PeerConnection.add_track`, we actually look for a free transceiver\n> (that is, one that is not sending a track already) and use it, or create a new transceiver if we don't find anything suitable. If you are very sure\n> that the remote peer added _N_ new video tracks, you can add _N_ video transceivers (using `PeerConnection.add_transceiver`) and begin the negotiation as\n> the offerer. If you didn't add the transceivers, the tracks added by the remote peer (the answerer) would be ignored.\n\nLet's look at an example:\n1. The first peer (Peer 1) joins - here it probably makes more sense for the client (so the Web Browser) to start the negotiation, as the server (Elixir App/\n`Forwarder` in the diagram) does not know how many tracks the client wants to add (the `2. offer/answer` message indicates the exchange of offer where the direction of\nthe arrow means the direction of the offer message).\n\n```mermaid\nflowchart LR\n  subgraph P1[\"Peer 1 (Web Browser)\"]\n    User-- \"1. addTrack(track11)\" -->PCW1[PeerConnection]\n  end\n\n  subgraph elixir [Elixir App]\n    PCE1[PeerConnection 1]-- \"3. {:track, track11}\" -->Forwarder\n  end\n\n  PCW1-. \"2. offer/answer\" .->PCE1\n```\n\n2. The second peer (Peer 2) joins - now we need to make a decision: we want Peer 2 to receive track from Peer 1, but Peer 2 also wants to send some tracks.\nWe can either:\n    - perform two negotiations: the first one, where Peer 2 is the offerer and adds their tracks, and the second one where the server is the offerer and adds\n    Peer 1's tracks to Peer 2's PeerConnection.\n\n    ```mermaid\n    flowchart LR\n      subgraph elixir [Elixir App]\n        PCE1[PeerConnection 1]\n        Forwarder-- \"4. add_track(track12)\" -->PCE2[PeerConnection 2]\n        PCE2-- \"3. {:track, track22}\" -->Forwarder\n      end\n\n      subgraph P2[\"Peer 2 (Web Browser)\"]\n        U2[User]-- \"1. addTrack(track22)\" -->PCW2[PeerConnection]\n        PCW2-- \"6. ontrack(track12)\" --> U2\n      end\n\n      PCW2-. \"2. offer/answer\" .->PCE2\n      PCE2-. \"5. offer/answer\" .->PCW2\n    ```\n\n    - assuming that we expect only _N_ tracks from Peer 2, we can use the tip above and\n    make sure that there are at least _N_ transceivers in Peer 2's PeerConnection on the Elixir side and do just a single negotiation.\n    Note that you can also add transceivers without associated track, that's what you would need to do if\n    _N_ in the diagram was greater than 1, because we only have a single track available.\n\n    ```mermaid\n    flowchart BR\n      subgraph elixir [Elixir App]\n        PCE1[PeerConnection 1]\n        Forwarder-- \"2. add_transceiver(track12)\" -->PCE2[PeerConnection 2]\n        PCE2-- \"4. {:track, track22}\" -->Forwarder\n      end\n\n      subgraph P2[\"Peer 2 (Web Browser)\"]\n        U2[User]-- \"1. addTrack(track22)\" -->PCW2[PeerConnection]\n        PCW2-- \"5. ontrack(track12)\" --> U2\n      end\n\n      PCE2-. \"3. offer/answer\" .->PCW2\n   ```\n\n> #### Negotiation needed {: .tip}\n> Instead of relying on gut feeling when it comes to performing the renegotiation, you can use the `negotiationneeded` event (of, in the case of Elixir WebRTC,\n> `{:ex_webrtc, _from, :negotiation_needed}` message). It should fire every time renegotiation is needed. Be careful though! If you plan to add five tracks\n> at once, do not perform five renegotiations by accident, when you could do only one at the very end!\n\n3. Lastly, Peer 1 also wants to receive Peer 2's tracks, so we need to add the new tracks to Peer 1's PeerConnection and perform the renegotiation there.\n\n```mermaid\nflowchart LR\n  subgraph P1[\"Peer 1 (Web Browser)\"]\n    PCW1[PeerConnection]-- \"3. ontrack(track12)\" --> U1\n  end\n\n  subgraph elixir [Elixir App]\n    Forwarder-- \"1. add_track(21)\" -->PCE1[PeerConnection 1]\n    PCE2[PeerConnection 2]\n  end\n\n  PCE1-. \"2. offer/answer\" .->PCW1\n```\n\n> #### Who owns the tracks? {: .warning}\n> Each of the tracks exists only in the context of its own PeerConnection. That means even if your Elixir App forwards media from one peer to\n> another, it only takes RTP packets from a track in the first peer's PeerConnection and feeds them to another track in the second peer's PeerConnection.\n> For instance, the role of `Forwarder` in the examples above would be to forward media in such way:\n>\n> ```mermaid\n> flowchart LR\n>   subgraph Forwarder\n>     track11 -.-> track12\n>     track22 -.-> track21\n>   end\n>   PC1[PeerConnection 1] --> track11\n>   PC2[PeerConnection 2] --> track22\n>   track12 --> PC2\n>   track21 --> PC1\n> ```\n>\n> This might be a bit counterintuitive, as in reality both of the tracks `track11` and `track12` still carry the same media stream.\n\nA similar process would happen for all of the joining/leaving peers. If you want to check an actual working example, check out the\n[Nexus](https://github.com/elixir-webrtc/apps/tree/master/nexus) - our Elixir, WebRTC-based videoconferencing demo app.","title":"Negotiation gets more complex - Modifying the session","ref":"modifying.html#negotiation-gets-more-complex"},{"type":"extras","doc":"When speaking about video codecs, we should also mention the idea of different types of frames.\n\nWe are interested in these types (although there can be more, depending on the codec):\n* I-frames (/intra-frames/keyframes) - these are complete, independent images and do not require other frames to be decoded\n* P-frames (predicted frames/delta-frames) - these only hold changes in the image from the previous frame.\n\nThanks to this, the size of all of the frames other than the keyframe can be greatly reduced, but:\n* loss of a keyframe or P-frame will result in a freeze and the receiver signaling that something is wrong and the video cannot be decoded\n* video playback can only start from a keyframe\n\nThus, it's very important not to lose the keyframes, or in the case of loss, swiftly respond to keyframe requests from the receiving peer and produce a new keyframe, as\ntypically (at least in WebRTC) intervals between unprompted keyframes in a video stream can be counted in tens of seconds. As you probably realize, a 15-second video\nfreeze would be quite disastrous! It's also important to request a new keyframe when a new peer that's supposed to receive media joins, so they can start video\nplayback right away instead of waiting.\n\nIf you want to learn more about digital video, check out the [Digital video introduction](https://github.com/leandromoreira/digital_video_introduction) project.","title":"Types of video frames - Modifying the session","ref":"modifying.html#types-of-video-frames"},{"type":"extras","doc":"When connecting two peers, you also have to make sure that all of them use the same video and audio codec, as the codec negotiation happens\ncompletely separately between independent PeerConnections. If you're not familiar with how codecs are negotiated in a WebRTC session, get back\nto the previous tutorial on consuming media data.\n\nIn a real scenario, you'd have to receive the RTP packet from the PeerConnection, inspect its payload type, find the codec associated with that payload type, find the payload type\nassociated with that codec on the other PeerConnection, and use it to overwrite the original payload type in the packet.\n\nBy default, `ExWebRTC.PeerConnection.send_rtp/4` will use the topmost negotiated codec, but you can change this behavior with\n`ExWebRTC.PeerConnection.set_sender_codec/3`.\n\nAnother option is to negotiate only one codec:\n\n```elixir\ncodec = %ExWebRTC.RTPCodecParameters{\n    payload_type: 96,\n    mime_type: \"video/VP8\",\n    clock_rate: 90_000\n}\n{:ok, pc} = PeerConnection.start_link(video_codecs: [codec])\n```\n\nAnd the last option is to perform server-side transcoding e.g. always negotiate both VP8 and H264 (in that preference), and if someone only supports H264, transcode their stream to VP8. \n\n\n> #### WebRTC internals {: .tip}\n> If you're developing using a Chromium-based browser, be sure to type out `chrome://webrtc-internals` in your address bar,\n> you'll access a lot of WebRTC-related stats.\n>\n> If you ever see a black screen with the \"loading\" spinning circle instead of your video in the `video` HTML element, be sure\n> to find your PeerConnection in the WebRTC internals, go to the `inbound-rtp(type=video, ...)` tab and check the `pliCount` stat.\n> If you see it growing, but the video still does not load, you most likely are missing a keyframe and are not responding\n> to the PLI (Picture Loss Indication) requests with a new keyframe.\n\nIn the case of a forwarding unit, like the example we have been examining in this section, we cannot really produce a keyframe, as we don't produce any video at all.\nThe only option is to send the keyframe request to the source, which in `ExWebRTC.PeerConnection` can be accomplished with the `PeerConnection.send_pli` function.\nPLI (Picture Loss Indication) is simply a type of RTCP packet.\n\nUsually, when forwarding media between peers, we would:\n* send PLI to source tracks when a new receiving peer joins,\n* forward PLI from source tracks to receiving tracks\n\nThis can be achieved with this piece of code similar to this:\n\n```elixir\ndefp handle_info(:new_peer_joined, state) do\n  for source <- state.sources do\n    :ok = PeerConnection.send_pli(source.peer_connection, source.video_track_id);\n  end\n  {:noreply, state}\nend\n\ndefp handle_info({:ex_webrtc, from, {:rtcp, packets}}, state) do\n  for packet <- packets do\n    case packet do\n      %ExRTCP.Packet.PayloadFeedback.PLI{media_ssrc: ssrc} ->\n        # TODO how to get the ids\n\n        :ok = PeerConnection.send_pli(peer_connection, source_track_id)\n\n      _other -> :ok\n    end\n  end\n\n  {:noreply, state}\nend\n```\n\nJust be careful to not overwhelm the source with PLIs! In a real application, we should probably implement some kind of rate limiting for the keyframe\nrequests.","title":"Matching codecs - Modifying the session","ref":"modifying.html#matching-codecs"},{"type":"extras","doc":"# Mastering Transceivers\n\n> #### Before You Start {: .info}\n> This guide assumes you have a basic understanding of the WebRTC API\n> and are looking for more advanced examples that demonstrate what you can accomplish with transceivers.\n> If you are new to this, a good starting point might be to first look at the \n> [MDN WebRTC tutorial](https://developer.mozilla.org/en-US/docs/Web/API/WebRTC_API).\n\nA transceiver is an entity responsible both for sending and receiving media data.\nIt consist of an RTP sender and RTP receiver.\nEach transceiver maps to one m-line in the SDP offer/answer.\n\nWhy do we need transceivers and cannot just operate on tracks?\n* We can establish a P2P connection even before obtaining access to media devices (see [Warmup](#warmup)).\nIn the previous version of the API, this was also possible but required creating\na dummy track and replacing it with the real one once it became available.\n* Transceivers map directly to the SDP offer/answer, providing high control over what is sent on which\ntransceiver.\nThis might have been especially important in the old days when media often wasn't bundled on a single ICE socket.\nIn such a case, every m-line could use a separate pair of ports.\nOn the other hand, `addTrack` always selects the first free transceiver, limiting this control.\n* They allow for offering to receive media in a manner consistent with offering to send media.\nIn the previous version of the API, the user had to call `addTrack` to offer to send media and \n`createOffer` with `{offerToReceiveVideo: 3}` to offer to only receive media, which was asymmetric and\ncounter-intuitve.\n\nThere're also a couple of other notes worth mentioning before moving forward.\n* `direction` is our (local) preferred direction of the transceiver and can never be changed by applying a remote offer/answer.\nWhen adding a transceiver, it is created with `sendrecv` direction by default.\nWhen applying a remote offer that contains new m-lines, a new transceiver is created with the `recvonly` direction,\neven when the offerer only wants to receive media.\nThe `direction` can later be changed by `addTrack` or `removeTrack`. \nSpecifically, `addTrack` sends media on the first available transceiver, provided this transceiver wasn't initially created by `addTransceiver`.\nSee [Stealing Transceiver](#stealing-transceiver).\n* `currentDirection` is a direction negotiated between the local and remote side, \nand it changes when applying local or remote SDP.\n* A transceiver is always created with an `RTCRtpReceiver` with a `MediaStreamTrack`. \nSee [Early Media](#early-media).\n* Applying a remote offer never steals explicitly created transceiver (i.e., added via `addTransceiver`).\nHowever, keep in mind this can happen when using `addTrack`.\nSee [Stealing Transceiver](#stealing-transceiver).\n\nWe also recommend reading these articles:\n* [Plan B vs Unified Plan](https://docs.google.com/document/d/1-ZfikoUtoJa9k-GZG1daN0BU3IjIanQ_JSscHxQesvU/edit#heading=h.wuu7dx8tnifl)\n* [The evolution of WebRTC 1.0](https://blog.mozilla.org/webrtc/the-evolution-of-webrtc/)\n* [Exploring RTCRtpTransceiver](https://blog.mozilla.org/webrtc/rtcrtptransceiver-explored/)","title":"Mastering Transceivers","ref":"mastering_transceivers.html"},{"type":"extras","doc":"*Warmup* is a technique where we establish or begin to establish WebRTC connection\nbefore gaining access to media devices.\nOnce the media becomes available, we attach a `MediaStreamTrack` to the peer connection using `replaceTrack`.\nThis process allows us to speed up the connection establishment time.\n\nRead more at: https://www.w3.org/TR/webrtc/#advanced-peer-to-peer-example-with-warm-up\n\n<!-- tabs-open -->","title":"Warmup - Mastering Transceivers","ref":"mastering_transceivers.html#warmup"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/46nozkbj/)\n\n```js\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\ntr = pc1.addTransceiver(\"audio\");\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\n// once MediaStreamTrack is ready,\n// start sending it with replaceTrack\nconst localStream = await navigator.mediaDevices.getUserMedia({ audio: true, video: false});\nawait tr.sender.replaceTrack(localStream.getTracks()[0]);\n```","title":"JavaScript - Mastering Transceivers","ref":"mastering_transceivers.html#javascript"},{"type":"extras","doc":"```elixir\n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\n{:ok, tr} = PeerConnection.add_transceiver(pc1, :audio)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\n# although in Elixir WebRTC user has to send media on their own,\n# using send_rtp function, we also added replace_track function\n# for parity with JavaScript API\ntrack = MediaStreamTrack.new(:audio)\n:ok = PeerConnection.replace_track(pc1, tr.sender.id, track)\n```\n\n<!-- tabs-close -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"This section outlines how you can establish a bidirectional connection\nusing a single negotiation and the *Warmup* technique. \n\nNote that applying an answer on pc1 triggers a `track` event.\n\n<!-- tabs-open -->","title":"Bidirectional connection using a single negotiation - Mastering Transceivers","ref":"mastering_transceivers.html#bidirectional-connection-using-a-single-negotiation"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/om0fk1ve/)\n\n```js\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\npc1.ontrack = ev => console.log(\"pc1 ontrack\");\npc2.ontrack = ev => console.log(\"pc2 ontrack\");\n\ntr = pc1.addTransceiver(\"audio\");\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\n\n// change direction from default \"recvonly\" to \"sendrecv\"\npc2.getTransceivers()[0].direction = \"sendrecv\";\n\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n```","title":"JavaScript - Mastering Transceivers","ref":"mastering_transceivers.html#javascript"},{"type":"extras","doc":"```elixir\n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\n{:ok, _tr} = PeerConnection.add_transceiver(pc1, :audio)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n\nreceive do {:ex_webrtc, ^pc2, {:track, _track}} = msg -> IO.inspect(msg) end\n\n[pc2_tr] = PeerConnection.get_transceivers(pc2)\n:ok = PeerConnection.set_transceiver_direction(pc2, pc2_tr.id, :sendrecv)\n\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\nreceive do {:ex_webrtc, ^pc1, {:track, _track}} = msg -> IO.inspect(msg) end\n```\n\n<!-- tabs-close -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"Offering to receive media tracks is a bit tricky as we can't force the other side to send something.\nTherefore, when we send an offer with the mline's direction set to `recvonly`, the other side will,\nby default, set such a track to inactive.\nTo make things work, we have to manually set the direction to `sendonly`.\n\n<!-- tabs-open -->","title":"Offer to receive data - Mastering Transceivers","ref":"mastering_transceivers.html#offer-to-receive-data"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/bhv8ds03/)\n\n```js\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\ntr = pc1.addTransceiver(\"audio\", { direction: \"recvonly\" });\n\noffer = await pc1.createOffer();\n\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\n\n// change direction from default \"recvonly\" to \"sendonly\"\n// in other case, when negotiation finishes,\n// currentDirection of this transceiver will be inactive\npc2.getTransceivers()[0].direction = \"sendonly\";\n\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\nconsole.log(pc2.getTransceivers()[0].direction);\nconsole.log(pc2.getTransceivers()[0].currentDirection);\n```","title":"JavaScript - Mastering Transceivers","ref":"mastering_transceivers.html#javascript"},{"type":"extras","doc":"```elixir\n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\n{:ok, _tr} = PeerConnection.add_transceiver(pc1, :audio, direction: :recvonly)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n\n[pc2_tr] = PeerConnection.get_transceivers(pc2)\n:ok = PeerConnection.set_transceiver_direction(pc2, pc2_tr.id, :sendonly)\n\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\n[pc2_tr] = PeerConnection.get_transceivers(pc2)\nIO.inspect(pc2_tr.direction)\nIO.inspect(pc2_tr.current_direction)\n```\n\n<!-- tabs-close -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"To reject incoming track, we simply change the transceiver's direction to \"inactive\".\nThings to note:\n* Track events are always emitted after applying the remote offer.\n* If we change the transceiver's direction to \"inactive\", \nwe will get a mute event on the track emitted when applying the remote offer.\n\n<!-- tabs-open -->","title":"Rejecting Incoming Track - Mastering Transceivers","ref":"mastering_transceivers.html#rejecting-incoming-track"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/qp9mLeag/)\n\n```js\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\npc2.ontrack = ev => {\n  ev.track.onmute = _ => console.log(\"pc2 track onmute\");\n  console.log(\"pc2 ontrack\");\n}\n\ntr = pc1.addTransceiver(\"audio\");\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\n// this will trigger track event\nawait pc2.setRemoteDescription(offer);\n\n// reject incoming track by setting the direction to \"inactive\"\npc2.getTransceivers()[0].direction = \"inactive\";\n\nanswer = await pc2.createAnswer();\nconsole.log(\"Setting local description on pc2\");\n// this will trigger mute event \nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n```","title":"JavaScript - Mastering Transceivers","ref":"mastering_transceivers.html#javascript"},{"type":"extras","doc":"```elixir\n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\n{:ok, _tr} = PeerConnection.add_transceiver(pc1, :audio)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n\nreceive do {:ex_webrtc, _pc, {:track, _track}} = msg -> IO.inspect(msg) end\n\n[pc2_tr] = PeerConnection.get_transceivers(pc2)\n:ok = PeerConnection.set_transceiver_direction(pc2, pc2_tr.id, :inactive)\n\n{:ok, answer} = PeerConnection.create_answer(pc2)\n\nIO.inspect(\"Setting local description on pc2\");\n:ok = PeerConnection.set_local_description(pc2, answer)\n\nreceive do {:ex_webrtc, _pc, {:track_muted, _track_id}} = msg -> IO.inspect(msg) end\n\n:ok = PeerConnection.set_remote_description(pc1, answer)\n```\n\n<!-- tabs-close -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"Stopping a transceiver immediately results in ceasing media transmission, \nbut it still requires renegotiation - after which the transceiver is removed from the connection's set of transceivers.\n\nNotes:\n* After stopping a transceiver, the SDP offer/answer will still contain its m-line, \nbut with the port number set to 0, indicating that this m-line is unused.\n* When applying a remote offer with unused m-lines, transceivers for those m-lines will be created, \nbut no track events will be emitted. \nOnce an answer is generated and applied (i.e., we finalize the negotiation process), \nthe transceivers created in the previous step will be removed.\n\n<!-- tabs-open -->","title":"Stopping Transceivers - Mastering Transceivers","ref":"mastering_transceivers.html#stopping-transceivers"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/r096z8o4/)\n\n```js\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\ntr1 = pc1.addTransceiver(\"audio\");\ntr2 = pc1.addTransceiver(\"video\");\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\ntr1.stop();\ntr2.stop();\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\n// negotiate once again even though negotiation is not needed\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\n\n// observe that after setting remote offer with unused m-lines,\n// stopped transceivers are created...\nawait pc2.setRemoteDescription(offer);\nconsole.log(pc2.getTransceivers());\n\nanswer = await pc2.createAnswer();\n// ...and removed \nawait pc2.setLocalDescription(answer);\nconsole.log(pc2.getTransceivers());\n\nawait pc1.setRemoteDescription(answer);\n```","title":"JavaScript - Mastering Transceivers","ref":"mastering_transceivers.html#javascript"},{"type":"extras","doc":"```elixir\n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\n{:ok, tr1} = PeerConnection.add_transceiver(pc1, :audio)\n{:ok, tr2} = PeerConnection.add_transceiver(pc1, :video)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\n:ok = PeerConnection.stop_transceiver(pc1, tr1.id)\n:ok = PeerConnection.stop_transceiver(pc1, tr2.id)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n\nIO.inspect(PeerConnection.get_transceivers(pc2))\n\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n\ntransceivers = PeerConnection.get_transceivers(pc2)\n[] = transceivers\nIO.inspect(transceivers)\n\n:ok = PeerConnection.set_remote_description(pc1, answer)\n```\n\n<!-- tabs-close -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"When calling stop on an `RTCRtpTransceiver`, it will eventually be removed from\nthe connection's set of transceivers.\nHowever, the number of m-lines in SDP offer/answer can never decrease.\nm-lines corresponding to stopped transceivers can be reused when a new transceiver appears.\nThis process is known as recycling m-lines, and it prevents SDP from becoming excessively large.\n\nThings to note:\n* A new transceiver will always attempt to reuse the first free m-line, regardless of its kind i.e.,\nwhether it's audio or video\n* The order of transceivers in a connection's set of transceivers matches the order in which\nthe transceivers were added, but it may be different than the order of m-lines in SDP offer/answer.\n\n<!-- tabs-open -->","title":"Recycling m-lines - Mastering Transceivers","ref":"mastering_transceivers.html#recycling-m-lines"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/m7yq3fv0/)\n\n```js\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\ntr1 = pc1.addTransceiver(\"audio\");\ntr2 = pc1.addTransceiver(\"video\");\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\ntr1.stop();\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\ntr3 = pc1.addTransceiver(\"video\");\n\n// Notice that createOffer will reuse (recycle)\n// free m-line, even though its initial type was audio.\n// However, pc1.getTransceivers() will return [tr1, tr3].\n// That's important as the order of transceivers doesn't\n// have to match the order of m-lines i.e. tr3 maps to m-line\n// with index 0 and tr1 maps to m-line with index 1.\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\n// notice that after renegotiation\n// pc1.getTransceivers() will only\n// return two (video) transceivers\nconsole.log(pc1.getTransceivers());\n```","title":"JavaScript - Mastering Transceivers","ref":"mastering_transceivers.html#javascript"},{"type":"extras","doc":"```elixir\n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\n{:ok, tr1} = PeerConnection.add_transceiver(pc1, :audio)\n{:ok, tr2} = PeerConnection.add_transceiver(pc1, :video)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\n:ok = PeerConnection.stop_transceiver(pc1, tr1.id)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\n{:ok, tr3} = PeerConnection.add_transceiver(pc1, :video)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\n[%{kind: :video}, %{kind: :video}] = PeerConnection.get_transceivers(pc1)\n```\n\n<!-- tabs-close -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"When a remote offer that contains a new m-line is applied, \nthe peer connection will attempt to find a transceiver it can use to associate with this m-line. \nThis is provided that the transceiver was created with `addTrack` and not with `addTransceiver`. \nBut why is this so? \nThe assumption is that when the user calls `addTrack` (and thereby creates a transceiver under the hood), \nthey don't pay attention to how this track is sent to the other side. \nHowever, this is not the case when the user explicitly creates a transceiver with `addTransceiver`.\n\n<!-- tabs-open -->","title":"Stealing Transceiver - Mastering Transceivers","ref":"mastering_transceivers.html#stealing-transceiver"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/to4g8erf/)\n\n```js\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\npc1Tr1 = pc1.addTransceiver(\"audio\");\npc2Tr1 = pc2.addTransceiver(\"audio\");\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\n// observe that pc2 has two transceivers\nconsole.log(pc2.getTransceivers());\n```","title":"JavaScript - Mastering Transceivers","ref":"mastering_transceivers.html#javascript"},{"type":"extras","doc":"```elixir\n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\n{:ok, pc1_tr1} = PeerConnection.add_transceiver(pc1, :audio)\n{:ok, pc2_tr1} = PeerConnection.add_transceiver(pc2, :audio)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\ntransceivers = PeerConnection.get_transceivers(pc2)\n2 = Enum.count(transceivers)\nIO.inspect(transceivers)\n```\n\n<!-- tabs-close -->\n\n\n<!-- tabs-open -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"[![JS FIDDLE](https://img.shields.io/badge/-JS%20FIDDLE-blueviolet)](https://jsfiddle.net/mickel8/agLzxuo9/)\n\n```js\nconst localStream = await navigator.mediaDevices.getUserMedia({ audio: true, video: false});\n\npc1 = new RTCPeerConnection();\npc2 = new RTCPeerConnection();\n\npc1Tr1 = pc1.addTransceiver(\"audio\");\npc2Sender = pc2.addTrack(localStream.getTracks()[0]);\n\noffer = await pc1.createOffer();\nawait pc1.setLocalDescription(offer);\nawait pc2.setRemoteDescription(offer);\nanswer = await pc2.createAnswer();\nawait pc2.setLocalDescription(answer);\nawait pc1.setRemoteDescription(answer);\n\n// observe that pc2 has one transceiver\nconsole.log(pc2.getTransceivers());\n```","title":"Java Script - Mastering Transceivers","ref":"mastering_transceivers.html#java-script"},{"type":"extras","doc":"```elixir\n# TODO not supported yet \n{:ok, pc1} = PeerConnection.start_link()\n{:ok, pc2} = PeerConnection.start_link()\n\ntrack = MediaStreamTrack.new(:audio)\n{:ok, pc1_tr1} = PeerConnection.add_transceiver(pc1, :audio)\n{:ok, _pc2_sender} = PeerConnection.add_track(pc2, track)\n\n{:ok, offer} = PeerConnection.create_offer(pc1)\n:ok = PeerConnection.set_local_description(pc1, offer)\n:ok = PeerConnection.set_remote_description(pc2, offer)\n{:ok, answer} = PeerConnection.create_answer(pc2)\n:ok = PeerConnection.set_local_description(pc2, answer)\n:ok = PeerConnection.set_remote_description(pc1, answer)\n\nIO.inspect(PeerConnection.get_transceivers(pc2))\n```\n\n<!-- tabs-close -->","title":"Elixir WebRTC - Mastering Transceivers","ref":"mastering_transceivers.html#elixir-webrtc"},{"type":"extras","doc":"A new transceiver is always created with an `RTCRtpReceiver` with a `MediaStreamTrack`.\nThis track is never removed.\nEven when the remote side calls `removeTrack`, only a `mute` event will be emitted.\n\nOne of the reasons of `MediaStreamTrack` to be always present in the `RTCRtpReceiver` was to support *Early Media*.\nAfter the initial negotiation, when one side offers to receive new media, the other side might generate an answer \nand immediately start sending data.\nThe first peer (thanks to the `MediaStreamTrack` being created beforehand) would be able to receive incoming data \nand display it even before the answer was received and applied.\nHowever, support for *Early Media* has been removed (see [here](https://github.com/w3c/webrtc-pc/issues/2880#issuecomment-1875121429)).\n\nIt is unclear what are other use-cases for the `MediaStreamTrack` to be always present and not removed when e.g. the other side calls `removeTrack`.","title":"Early Media - Mastering Transceivers","ref":"mastering_transceivers.html#early-media"},{"type":"extras","doc":"# Debugging WebRTC\n\nWebRTC is a complex technology with a lot of moving pieces under the hood, which can make dealing with issues very challenging.\nFortunately, there are quite a lot of tools and techniques created to make this process a bit easier.\n\nIn this tutorial, we will go through some of the methods you can use to debug WebRTC.","title":"Debugging WebRTC","ref":"debugging.html"},{"type":"extras","doc":"If you're using a Chromium-based web browser, you're in luck. Chromium provides _WebRTC Internals_ - a page with WebRTC stats\nabout currently used PeerConnections. Access the address `chrome://webrtc-internals` to see something like this:\n\n \n   \n \n\nThe visual aspects may not knock you off your feet, but the page provides a lot of useful information and stats. Check out this [blog post](https://getstream.io/blog/debugging-webrtc-calls/)\nto learn more about what's in the WebRTC Internals, or simply explore the tool and see what you find useful.\n\n> #### Other browsers {: .info}\n> Chromium's WebRTC Internals is arguably the best tool of this kind. Firefox provides `about:webrtc` page, but it's not nearly as featureful as `chrome://webrtc-internals`.\n> Safari does not have an equivalent, but it allows you to enable verbose logging of WebRTC-related stuff.","title":"WebRTC Internals - Debugging WebRTC","ref":"debugging.html#webrtc-internals"},{"type":"extras","doc":"While Chromium's `chrome://webrtc-internals` provides you with stats about PeerConnection in the browser, Elixir WebRTC has its [dashboard](https://github.com/elixir-webrtc/ex_webrtc_dashboard).\nIt is an extension of [Phoenix LiveDashboard](https://github.com/phoenixframework/phoenix_live_dashboard) and can be added with a few lines of code to your Phoenix\nproject. It provides information about the PeerConnection state, ICE candidates, inbound and outbound RTP, etc. It is not as rich as the WebRTC Internals but still may\nbe very helpful when debugging.\n\n \n   \n \n\nWe won't go through each of the sections - if you're familiar with WebRTC Internals, you'll feel right at home in the Elixir WebRTC dashboard.","title":"Elixir WebRTC Dashboard - Debugging WebRTC","ref":"debugging.html#elixir-webrtc-dashboard"},{"type":"extras","doc":"Sometimes it's also worth taking a look at browser logs - specific errors may tell you more than just graphs in WebRTC Internals.\n\nTo turn on logs in Chromium, you can use\n\n```shell\nchromium --enable-logging='stderr' --vmodule='*/webrtc/*=2'\n```\n\nwhere `chromium` is either your Chrome or Chromium binary. The `vmodule` option will filter the logs to only WebRTC-related stuff.\nThe amount of logs can be a little overwhelming - just try to look for keywords related to your problem.","title":"Turning on logs in Chromium - Debugging WebRTC","ref":"debugging.html#turning-on-logs-in-chromium"},{"type":"extras","doc":"In case of very cryptic issues, you might be tempted to inspect the RTP packets received by the browser. The obvious choice would be to just\nopen up Wireshark and capture the RTP traffic directly. Unfortunately, WebRTC by design encrypts all of the RTP data, so the amount of information\nyou can obtain from packets captured live is highly limited. There are two solutions:\n\n- run Chromium with `--disable-webrtc-encryption` flag. In this case, the other WebRTC peer also needs to somehow bypass encryption, which (as of now) is\nimpossible in Elixir WebRTC.\n\n- make Chromium dump received RTP packets after they were decrypted.\n\nIf you're using Elixir WebRTC, only the second option is viable, and arguably, a bit easier. To make Chromium dump the RTP packets, run it with\n\n```shell\nchromium --enable-logging=stderr -v=3 --force-fieldtrials=WebRTC-Debugging-RtpDump/Enabled/ > log.txt 2>&1\n```\n\nThis will save logs mixed up with RTP packets to `log.txt`. We need to filter out non-RTP stuff with\n\n```shell\ngrep RTP_DUMP log.txt > rtp-dump.txt\n```\n\nWe can use the `text2pcap` utility (which comes with Wireshark) to convert the logs to `.pcap` file\n\n```shell\ntext2pcap -D -u 5443,62132 -t %H:%M:%S.%f rtp-dump.txt rtp-dump.pcap\n```\n\nNow, you should be able to open the `rtp-dump.pcap` file with Wireshark and inspect the packets!\n\n> #### What about Firefox? {: .info}\n> You can also do similar things in Firefox. Check out this [SO post](https://stackoverflow.com/questions/74399155/how-do-i-see-internal-webrtc-logs-in-firefox)\n> to learn how to turn on WebRTC logs, and this [blog post](https://blog.mozilla.org/webrtc/debugging-encrypted-rtp-is-more-fun-than-it-used-to-be/)\n> on how to dump RTP packets.","title":"Dumping raw RTP packets from Chromium - Debugging WebRTC","ref":"debugging.html#dumping-raw-rtp-packets-from-chromium"},{"type":"extras","doc":"This section contains a bunch of questions related to _something not working_ when using Elixir WebRTC or WebRTC in general. Some of them can be diagnosed with the\ntechiniques described earlier in this tutorial and can be remedied with simple fixes.","title":"FAQ - Debugging WebRTC","ref":"debugging.html#faq"},{"type":"extras","doc":"Firstly, take a look at `chrome://webrtc-internals`. Make sure that there's nothing marked with a red background in the API trace section, and that\nyour PeerConnection is in the `connected` state. Find the `inbound-rtp` section (either table with stats or graphs, the graph section\nwill be called _Stats graphs for inbound-rtp (kind=video, mid=2, ...)_) related to your track.\n\n![PeerConnection state](assets/state.jpg)\n\nIf you cannot find the `inbound-rtp` section, make sure you properly added and negotiated the tracks. The SDP offer and answer can be inspected in the API trace section of\n`chrome://webrtc-internals`.\n\n![InboundRTP](assets/inbound.jpg)\n\nAssuming you have found your `inbound-rtp` section, take a look at `packetsReceived` graph.\n\n#### 1. `packetsReceived` not growing\n\nIf it's 0 and not growing, the transceiver is not getting packets at all or rejecting the packets.\nTake a look at _Stats graphs for candidate-pair (state=succeeded, id=XXX)_ (the one in bold) section and find `packetsReceived`. Assuming that you multiplex all WebRTC data\non a single transport (which is always the case for Elixir WebRTC), this stat shows all of the packets received by the PeerConnection. If it's not growing, once again\nmake sure your PeerConnection is in a `connected` state and you're sending packets properly on the Elixir WebRTC end. If it's growing, the issue is with the transceiver rejecting\nthe packets.\n\nA common issue in this case is an invalid direction of the transceiver you're trying to receive data on. If the direction is `sendonly` or `inactive`, the\ntransceiver will drop all of the incoming packets. For instance, creating a `recvonly` transceiver and performing a negotiation will result in a transceiver with `inactive`\ndirection (not `sendonly`!) on the remote peer, which might be counterintuitive. Make sure you properly negotiated the session by inspecting the SDP offers and answers.\nIf you're sure that the session was properly negotiated, reproduce the issue, create an RTP dump, and share it with us - this might be an Elixir WebRTC bug.\n\n![CandidatePair](assets/pair.jpg)\n\n#### 2. `packetsReceived` growing, but `framesDecoded` stays on 0 (in case of video)\n\nIf packets are received, but the `framesDecoded` stat stays on 0 (and/or `framesDropped` stat is growing), the issue is either with invalid media data (unlikely, if\nyou're just forwarding the media data) or with the lack of a keyframe. In such a case, take a look at the `keyFramesDecoded` stat (if it stays on 0, no keyframes were received)\nand the `pliCount` stat. If it's growing indefinitely, the other peer is ignoring keyframe requests (more specifically, PLI - Picture Loss Indication). Make sure you're properly\nhandling PLI on the remote PeerConnection, or that you produce a keyframe periodically.\n\nThe issues also might be caused by the fact that you're trying to send RTP packets with\nan invalid codec. For instance, you're wanted to negotiate H264, but it was rejected (and you did not realize that), and now you're trying to send H264, Elixir WebRTC will\nassign some unrelated payload type to the packets. The browser obviously won't be able to decode that.","title":"1. I'm sending data from Elixir WebRTC to a browser, but my HTML video element is loading infinitely and not showing the video. - Debugging WebRTC","ref":"debugging.html#1-i-m-sending-data-from-elixir-webrtc-to-a-browser-but-my-html-video-element-is-loading-infinitely-and-not-showing-the-video"},{"type":"extras","doc":"When using Simulcast in a browser, make sure that you allocate not too little bandwidth for the resolution of the Simulcast layers. Otherwise,\nif the browser deems that there is too little bandwidth available, or that the CPU load is too big, it might decide to just stop sending one of the layers.\n\n```js\nmediaConstraints = {video: {width: { ideal: 1280 }, height: { ideal: 720 } }, audio: true};\nconst localStream = await navigator.mediaDevices.getUserMedia(mediaConstraints);\n\nconst pc = new RTCPeerConnection();\npc.addTransceivers(localStream.getVideoTracks()[0], {\n  sendEncodings: [\n    { rid: \"h\", maxBitrate: 1200 * 1024},\n    { rid: \"m\", scaleResolutionDownBy: 2, maxBitrate: 600 * 1024},\n    { rid: \"l\", scaleResolutionDownBy: 4, maxBitrate: 300 * 1024 },\n  ],\n});\n```\n\nYou can take a look at this [snippet](https://source.chromium.org/chromium/chromium/src/+/main:third_party/webrtc/video/config/simulcast.cc;l=79?q=simulcast.cc)\nfrom `libwebrtc` to have an idea of what values should you use.","title":"2. Some of my Simulcast layers are not sent at all. - Debugging WebRTC","ref":"debugging.html#2-some-of-my-simulcast-layers-are-not-sent-at-all"},{"type":"extras","doc":"When using Elixir WebRTC, make sure you open the ephemeral range of UDP ports in your firewall. WebRTC uses a random port in this range, one for every PeerConnection.\nYou can also configure PeerConnection to use a specific port range by doing\n\n```elixir\n{:ok, pc} = ExWebRTC.PeerConnection.start(ice_port_range: 50_000..50_100)\n```\n\nOtherwise, the connection won't be established at all, or just in one direction.\n\nRead more in our [Deploying tutorial](../deploying/bare.md#allow-udp-traffic-in-your-firewall)!","title":"3. Firewall - Debugging WebRTC","ref":"debugging.html#3-firewall"},{"type":"extras","doc":"# Deploying on bare machines\n\nDeploying WebRTC applications can be cumbersome.\nHere are a few details you should keep in mind when trying to push your project into production on a bare machine.","title":"Deploying on bare machines","ref":"bare.html"},{"type":"extras","doc":"In most cases, WebRTC uses UDP to exchange audio and video data.\nTherefore, you have to allow UDP traffic in your firewall.\nIn Linux-based systems that use `ufw`, you can do this with the following command:\n\n```sh\nufw allow 50000:60000/udp\n```\n\nOur ICE implementation, by default, uses an ephemeral port range, so it might vary depending on your operating system.\nHowever, you can specify an exact port range that ICE will use when creating a new peer connection, e.g.:\n\n```elixir\nPeerConnection.start_link(ice_port_range: 50_000..60_000)\n```","title":"Allow UDP traffic in your firewall - Deploying on bare machines","ref":"bare.html#allow-udp-traffic-in-your-firewall"},{"type":"extras","doc":"In some cases, when ICE really cannot find a UDP path, it may fall back to a TCP connection.\nHowever, since our ICE implementation does not support TCP yet, you don't need to take any extra steps here :)","title":"Allow TCP traffic in your firewall - Deploying on bare machines","ref":"bare.html#allow-tcp-traffic-in-your-firewall"},{"type":"extras","doc":"If you are running your application using Docker, we recommend using the `--network host` option.\nIf that's not possible (e.g. you are running on macOS), you have to manually export the ports used by ICE, e.g.:\n\n```\ndocker run -p 50000-50010/udp myapp\n```\n\nKeep in mind that exporting a lot of ports might take a lot of time or even cause the Docker daemon to timeout.\nThat's why we recommend using host's network.","title":"Export ports in your Docker container - Deploying on bare machines","ref":"bare.html#export-ports-in-your-docker-container"},{"type":"extras","doc":"The server hosting your frontend site must have HTTPS enabled.\nThis is a requirement for accessing the user's microphone and camera devices.\nNot using HTTPS on addresses different than localhost will result in `navigator.mediaDevices` being `null`.","title":"Enable HTTPS in your frontend - Deploying on bare machines","ref":"bare.html#enable-https-in-your-frontend"},{"type":"extras","doc":"WebSockets are a common option for the signalling channel.\nIf you are using a reverse-proxy like nginx, to make your WebSocket connections work,\nyou have to preserve the original (client) request headers.\nIn other words, you need to add the following lines to your endpoint handling websocket connections configuration:\n\n```\nproxy_http_version 1.1;\nproxy_set_header Upgrade $http_upgrade;\nproxy_set_header Connection \"upgrade\";\n```\n\nRead more [here](https://nginx.org/en/docs/http/websocket.html).","title":"Proxy WebSocket connections - Deploying on bare machines","ref":"bare.html#proxy-websocket-connections"},{"type":"extras","doc":"If you are deploying your application behind a NAT, you have to configure a STUN\nserver that will allow it to discover its public IP address.\nIn Elixir WebRTC this will be:\n\n```elixir\nPeerConnection.start_link(ice_servers: [%{urls: \"stun:stun.l.google.com:19302\"}])\n```\n\nGoogle's STUN server is publicaly available, but keep in mind that you depend on\nsomeone else's infrastructure.\nIf it goes down, you can do nothing about it.\nTo avoid that, you would need to host your own STUN server.\nKeep in mind, that TURN servers are also STUN servers so if you have already TURN deployed,\nyou don't need to specify additional STUN servers.\nAnd as a TURN server, you can always use our [Rel](https://github.com/elixir-webrtc/rel)!","title":"Configure STUN servers - Deploying on bare machines","ref":"bare.html#configure-stun-servers"},{"type":"extras","doc":"If your application is deployed behind a very restrictive NAT, which should be very rare (e.g. a symmetric NAT),\nyou will need to configure a TURN server.\nIn most cases, TURN servers are needed on the client side as you don't have any control\nover a network your clients connect from.\nFor testing and experimental purposes, you can use our publicly available TURN called [Rel](https://github.com/elixir-webrtc/rel)!","title":"Configure TURN servers - Deploying on bare machines","ref":"bare.html#configure-turn-servers"},{"type":"extras","doc":"# Deploying on Fly.io\n\nElixir WebRTC-based apps can be easily deployed on [Fly.io](https://fly.io)!\n\nThere are just three things you need to do:\n\n* configure a STUN server both on the client and server side\n* use a custom Fly.io IP filter on the server side\n* slightly modify the auto-generated Dockerfile \n\nIn JavaScript code:\n\n```js\npc = new RTCPeerConnection({\n  iceServers: [{ urls: \"stun:stun.l.google.com:19302\" }],\n});\n```\n\nIn Elixir code:\n\n```elixir\nip_filter = Application.get_env(:your_app, :ice_ip_filter)\n\n{:ok, pc} =\n  PeerConnection.start_link(\n    ice_ip_filter: ip_filter,\n    ice_servers: [%{urls: \"stun:stun.l.google.com:19302\"}]\n  )\n```\n\nIn `runtime.exs`:\n\n```elixir\nif System.get_env(\"FLY_APP_NAME\") do\n  config :your_app, ice_ip_filter: &ExWebRTC.ICE.FlyIpFilter.ip_filter/1\nend\n```\n\nNow:\n1. Run `fly launch`. It will generate a Dockerfile that will fail to build.\n2. Introduce the following changes \n\n    ```diff\n    - ARG ELIXIR_VERSION=1.16.0\n    - ARG OTP_VERSION=26.2.1\n    - ARG DEBIAN_VERSION=bullseye-20231009-slim\n    + ARG ELIXIR_VERSION=1.17.2\n    + ARG OTP_VERSION=27.0.1\n    + ARG DEBIAN_VERSION=bookworm-20240701-slim\n\n    # when building on arm64, you will also need to add libsrtp2-dev\n    - RUN apt-get update -y && apt-get install -y build-essential git \\\n    -     && apt-get clean && rm -f /var/lib/apt/lists/*_*\n    + RUN apt-get update -y && apt-get install -y build-essential git pkg-config libssl-dev \\\n    +     && apt-get clean && rm -f /var/lib/apt/lists/*_*\n    ```\n\n3. Run `fly deploy` to retry.\n\nThat's it!\nNo special UDP port exports or dedicated IP address are needed :)","title":"Deploying on Fly.io","ref":"fly.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}